# SwaggerClient-php
REST API Brownbook

This PHP package is automatically generated by the [Swagger Codegen](https://github.com/swagger-api/swagger-codegen) project:

- API version: 1.0
- Build package: io.swagger.codegen.v3.generators.php.PhpClientCodegen

## Requirements

PHP 5.5 and later

## Installation & Usage
### Composer

To install the bindings via [Composer](http://getcomposer.org/), add the following to `composer.json`:

```
{
  "repositories": [
    {
      "type": "git",
      "url": "https://github.com/GIT_USER_ID/GIT_REPO_ID.git"
    }
  ],
  "require": {
    "GIT_USER_ID/GIT_REPO_ID": "*@dev"
  }
}
```

Then run `composer install`

### Manual Installation

Download the files and include `autoload.php`:

```php
    require_once('/path/to/SwaggerClient-php/vendor/autoload.php');
```

## Tests

To run the unit tests:

```
composer install
./vendor/bin/phpunit
```

## Getting Started

Please follow the [installation procedure](#installation--usage) and then run the following:

```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

$apiInstance = new Swagger\Client\Api\BusinessApi(
    // If you want use custom http client, pass your client which implements `GuzzleHttp\ClientInterface`.
    // This is optional, `GuzzleHttp\Client` will be used as default.
    new GuzzleHttp\Client()
);
$authorization = "Bearer {token}"; // string | 
$body = new \Swagger\Client\Model\ApiStats(); // \Swagger\Client\Model\ApiStats | 

try {
    $result = $apiInstance->exportBusiness($authorization, $body);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling BusinessApi->exportBusiness: ', $e->getMessage(), PHP_EOL;
}
?>
```

## Documentation for API Endpoints

All URIs are relative to *https://api.brownbook.net/*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*BusinessApi* | [**exportBusiness**](docs/Api/BusinessApi.md#exportbusiness) | **GET** /business/export | https://api.brownbook.net/api/v1/business/export
*BusinessesApi* | [**deleteBusinessReply**](docs/Api/BusinessesApi.md#deletebusinessreply) | **DELETE** /businesses/reviews/reply/{replyId} | deleteBusinessReply
*BusinessesApi* | [**getBusiness**](docs/Api/BusinessesApi.md#getbusiness) | **GET** /businesses/{businessId} | https://api.brownbook.net/businesses/{businessId}
*BusinessesApi* | [**getBusinessDupe**](docs/Api/BusinessesApi.md#getbusinessdupe) | **GET** /businesses/dupe/{businessId} | https://api.brownbook.net/businesses/dupe/{businessId}
*BusinessesApi* | [**getBusinesses**](docs/Api/BusinessesApi.md#getbusinesses) | **GET** /businesses | https://api.brownbook.net/businesses/
*BusinessesApi* | [**getBusinessesReviews**](docs/Api/BusinessesApi.md#getbusinessesreviews) | **GET** /businesses/reviews | https://api.brownbook.net/businesses/reviews/
*BusinessesApi* | [**postBusinessReply**](docs/Api/BusinessesApi.md#postbusinessreply) | **PUT** /businesses/reviews/reply/{commentId} | https://api.brownbook.net/businesses/reviews/{commentId}
*BusinessesApi* | [**postBusinesses**](docs/Api/BusinessesApi.md#postbusinesses) | **POST** /businesses | https://api.brownbook.net/businesses/
*BusinessesApi* | [**unclaimBusiness**](docs/Api/BusinessesApi.md#unclaimbusiness) | **GET** /businesses/unclaim/{businessId} | https://api.brownbook.net/businesses/unclaim/{businessId}
*BusinessesApi* | [**updateBusinessReply**](docs/Api/BusinessesApi.md#updatebusinessreply) | **POST** /businesses/reviews/reply/{replyId} | https://api.brownbook.net/businesses/reviews/{replyId}
*BusinessesApi* | [**updatedBusiness**](docs/Api/BusinessesApi.md#updatedbusiness) | **POST** /businesses/{businessId} | https://api.brownbook.net/businesses/{businessId}
*TokenApi* | [**token**](docs/Api/TokenApi.md#token) | **POST** /token | https://api.brownbook.net/token/

## Documentation For Models

 - [AdditionalWebsite](docs/Model/AdditionalWebsite.md)
 - [ApiStats](docs/Model/ApiStats.md)
 - [ApiStatsCollection](docs/Model/ApiStatsCollection.md)
 - [Business](docs/Model/Business.md)
 - [Business404NotFound](docs/Model/Business404NotFound.md)
 - [Business500Error](docs/Model/Business500Error.md)
 - [BusinessCreated200](docs/Model/BusinessCreated200.md)
 - [BusinessCreatingError](docs/Model/BusinessCreatingError.md)
 - [BusinessDetails](docs/Model/BusinessDetails.md)
 - [BusinessDetailsWhenUpdate](docs/Model/BusinessDetailsWhenUpdate.md)
 - [BusinessHours](docs/Model/BusinessHours.md)
 - [BusinessMultiple](docs/Model/BusinessMultiple.md)
 - [BusinessSchemaError](docs/Model/BusinessSchemaError.md)
 - [BusinessSchemaErrorIssues](docs/Model/BusinessSchemaErrorIssues.md)
 - [BusinessUpdating](docs/Model/BusinessUpdating.md)
 - [Fields](docs/Model/Fields.md)
 - [FieldsForBusinessMultiple](docs/Model/FieldsForBusinessMultiple.md)
 - [FieldsForUpdate](docs/Model/FieldsForUpdate.md)
 - [Hour](docs/Model/Hour.md)
 - [Image](docs/Model/Image.md)
 - [Interval](docs/Model/Interval.md)
 - [Logo](docs/Model/Logo.md)
 - [Payments](docs/Model/Payments.md)
 - [ReplyAlreadyCreatedResponse](docs/Model/ReplyAlreadyCreatedResponse.md)
 - [ReplyDeleteResponse](docs/Model/ReplyDeleteResponse.md)
 - [ReplyEditedResponse](docs/Model/ReplyEditedResponse.md)
 - [ReplyEditedResponse400](docs/Model/ReplyEditedResponse400.md)
 - [ReplyEditedResponse405](docs/Model/ReplyEditedResponse405.md)
 - [ReplyReplyIdBody](docs/Model/ReplyReplyIdBody.md)
 - [ReplyReplyIdBody1](docs/Model/ReplyReplyIdBody1.md)
 - [ReplyResponse](docs/Model/ReplyResponse.md)
 - [ReplyResponse400](docs/Model/ReplyResponse400.md)
 - [ReplyResponse401](docs/Model/ReplyResponse401.md)
 - [ReplyResponse404](docs/Model/ReplyResponse404.md)
 - [ReplyResponse404R](docs/Model/ReplyResponse404R.md)
 - [ReviewObject](docs/Model/ReviewObject.md)
 - [ReviewReplyObject](docs/Model/ReviewReplyObject.md)
 - [Reviews200](docs/Model/Reviews200.md)
 - [SpecialOffer](docs/Model/SpecialOffer.md)
 - [Token](docs/Model/Token.md)
 - [TokenExpired](docs/Model/TokenExpired.md)
 - [TokenResponse200](docs/Model/TokenResponse200.md)
 - [TokenResponse400](docs/Model/TokenResponse400.md)
 - [TokenResponse401](docs/Model/TokenResponse401.md)
 - [TokenResponse500](docs/Model/TokenResponse500.md)

## Documentation For Authorization

 All endpoints do not require authorization.


## Author



