# Swagger\Client\BusinessesApi

All URIs are relative to *https://api.brownbook.net/*

Method | HTTP request | Description
------------- | ------------- | -------------
[**deleteBusinessReply**](BusinessesApi.md#deletebusinessreply) | **DELETE** /businesses/reviews/reply/{replyId} | deleteBusinessReply
[**getBusiness**](BusinessesApi.md#getbusiness) | **GET** /businesses/{businessId} | https://api.brownbook.net/businesses/{businessId}
[**getBusinessDupe**](BusinessesApi.md#getbusinessdupe) | **GET** /businesses/dupe/{businessId} | https://api.brownbook.net/businesses/dupe/{businessId}
[**getBusinesses**](BusinessesApi.md#getbusinesses) | **GET** /businesses | https://api.brownbook.net/businesses/
[**getBusinessesReviews**](BusinessesApi.md#getbusinessesreviews) | **GET** /businesses/reviews | https://api.brownbook.net/businesses/reviews/
[**postBusinessReply**](BusinessesApi.md#postbusinessreply) | **PUT** /businesses/reviews/reply/{commentId} | https://api.brownbook.net/businesses/reviews/{commentId}
[**postBusinesses**](BusinessesApi.md#postbusinesses) | **POST** /businesses | https://api.brownbook.net/businesses/
[**unclaimBusiness**](BusinessesApi.md#unclaimbusiness) | **GET** /businesses/unclaim/{businessId} | https://api.brownbook.net/businesses/unclaim/{businessId}
[**updateBusinessReply**](BusinessesApi.md#updatebusinessreply) | **POST** /businesses/reviews/reply/{replyId} | https://api.brownbook.net/businesses/reviews/{replyId}
[**updatedBusiness**](BusinessesApi.md#updatedbusiness) | **POST** /businesses/{businessId} | https://api.brownbook.net/businesses/{businessId}

# **deleteBusinessReply**
> \Swagger\Client\Model\ReplyDeleteResponse[] deleteBusinessReply($body, $reply_id, $authorization)

deleteBusinessReply

Deletes reply on a business comment.

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

$apiInstance = new Swagger\Client\Api\BusinessesApi(
    // If you want use custom http client, pass your client which implements `GuzzleHttp\ClientInterface`.
    // This is optional, `GuzzleHttp\Client` will be used as default.
    new GuzzleHttp\Client()
);
$body = new \Swagger\Client\Model\ReplyReplyIdBody1(); // \Swagger\Client\Model\ReplyReplyIdBody1 | 
$reply_id = "reply_id_example"; // string | 
$authorization = "Bearer {token}"; // string | 

try {
    $result = $apiInstance->deleteBusinessReply($body, $reply_id, $authorization);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling BusinessesApi->deleteBusinessReply: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**\Swagger\Client\Model\ReplyReplyIdBody1**](../Model/ReplyReplyIdBody1.md)|  |
 **reply_id** | **string**|  |
 **authorization** | **string**|  | [optional] [default to Bearer {token}]

### Return type

[**\Swagger\Client\Model\ReplyDeleteResponse[]**](../Model/ReplyDeleteResponse.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **getBusiness**
> \Swagger\Client\Model\BusinessDetails getBusiness($content_type, $accept, $authorization)

https://api.brownbook.net/businesses/{businessId}

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

$apiInstance = new Swagger\Client\Api\BusinessesApi(
    // If you want use custom http client, pass your client which implements `GuzzleHttp\ClientInterface`.
    // This is optional, `GuzzleHttp\Client` will be used as default.
    new GuzzleHttp\Client()
);
$content_type = "content_type_example"; // string | 
$accept = "accept_example"; // string | 
$authorization = "Bearer {token}"; // string | 

try {
    $result = $apiInstance->getBusiness($content_type, $accept, $authorization);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling BusinessesApi->getBusiness: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **content_type** | **string**|  |
 **accept** | **string**|  |
 **authorization** | **string**|  | [optional] [default to Bearer {token}]

### Return type

[**\Swagger\Client\Model\BusinessDetails**](../Model/BusinessDetails.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **getBusinessDupe**
> getBusinessDupe($business_id, $authorization)

https://api.brownbook.net/businesses/dupe/{businessId}

Mark a business to be suppressed from listing and optionaly adding a canonical listing id to redirect it to, or unmark it as such.

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

$apiInstance = new Swagger\Client\Api\BusinessesApi(
    // If you want use custom http client, pass your client which implements `GuzzleHttp\ClientInterface`.
    // This is optional, `GuzzleHttp\Client` will be used as default.
    new GuzzleHttp\Client()
);
$business_id = "business_id_example"; // string | 
$authorization = "Bearer {token}"; // string | 

try {
    $apiInstance->getBusinessDupe($business_id, $authorization);
} catch (Exception $e) {
    echo 'Exception when calling BusinessesApi->getBusinessDupe: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **business_id** | **string**|  |
 **authorization** | **string**|  | [optional] [default to Bearer {token}]

### Return type

void (empty response body)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **getBusinesses**
> \Swagger\Client\Model\BusinessMultiple[] getBusinesses($country, $_limit, $_offset, $authorization, $content_type, $accept)

https://api.brownbook.net/businesses/

Gets BusinessSearchResult objects.

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

$apiInstance = new Swagger\Client\Api\BusinessesApi(
    // If you want use custom http client, pass your client which implements `GuzzleHttp\ClientInterface`.
    // This is optional, `GuzzleHttp\Client` will be used as default.
    new GuzzleHttp\Client()
);
$country = "country_example"; // string | Specify country for filtering businesses (required) (US,CA,AU)
$_limit = 56; // int | Takes specified number of records
$_offset = 56; // int | Offset the results from this number
$authorization = "Bearer {token}"; // string | 
$content_type = "content_type_example"; // string | 
$accept = "accept_example"; // string | 

try {
    $result = $apiInstance->getBusinesses($country, $_limit, $_offset, $authorization, $content_type, $accept);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling BusinessesApi->getBusinesses: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **country** | **string**| Specify country for filtering businesses (required) (US,CA,AU) |
 **_limit** | **int**| Takes specified number of records |
 **_offset** | **int**| Offset the results from this number |
 **authorization** | **string**|  | [optional] [default to Bearer {token}]
 **content_type** | **string**|  | [optional]
 **accept** | **string**|  | [optional]

### Return type

[**\Swagger\Client\Model\BusinessMultiple[]**](../Model/BusinessMultiple.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **getBusinessesReviews**
> \Swagger\Client\Model\Reviews200 getBusinessesReviews($business_id, $content_type, $accept, $authorization, $num, $limit, $page, $offset, $order_by, $sort_by)

https://api.brownbook.net/businesses/reviews/

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

$apiInstance = new Swagger\Client\Api\BusinessesApi(
    // If you want use custom http client, pass your client which implements `GuzzleHttp\ClientInterface`.
    // This is optional, `GuzzleHttp\Client` will be used as default.
    new GuzzleHttp\Client()
);
$business_id = 56; // int | brownbook business Id (required)
$content_type = "content_type_example"; // string | 
$accept = "accept_example"; // string | 
$authorization = "Bearer {token}"; // string | 
$num = 56; // int | Page number (2 page will make an offset 1000 * 2 = 2000, 1 by default)
$limit = 56; // int | Result limit (1000 by default)
$page = 56; // int | Page number parameter
$offset = 56; // int | Offset parameter. If offset is filled and page is empty then page will be as ceil(($offset+$offset) / $num + 1).
$order_by = "order_by_example"; // string | Order parameter. By default created_at. Can be created_at, id, updated_at, rating
$sort_by = "sort_by_example"; // string | Sort parameter. By default ascending (asc). Can have 2 stages - asc or desc

try {
    $result = $apiInstance->getBusinessesReviews($business_id, $content_type, $accept, $authorization, $num, $limit, $page, $offset, $order_by, $sort_by);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling BusinessesApi->getBusinessesReviews: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **business_id** | **int**| brownbook business Id (required) |
 **content_type** | **string**|  |
 **accept** | **string**|  |
 **authorization** | **string**|  | [optional] [default to Bearer {token}]
 **num** | **int**| Page number (2 page will make an offset 1000 * 2 &#x3D; 2000, 1 by default) | [optional]
 **limit** | **int**| Result limit (1000 by default) | [optional]
 **page** | **int**| Page number parameter | [optional]
 **offset** | **int**| Offset parameter. If offset is filled and page is empty then page will be as ceil(($offset+$offset) / $num + 1). | [optional]
 **order_by** | **string**| Order parameter. By default created_at. Can be created_at, id, updated_at, rating | [optional]
 **sort_by** | **string**| Sort parameter. By default ascending (asc). Can have 2 stages - asc or desc | [optional]

### Return type

[**\Swagger\Client\Model\Reviews200**](../Model/Reviews200.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **postBusinessReply**
> \Swagger\Client\Model\ReplyResponse[] postBusinessReply($comment_id, $message, $business_id, $authorization)

https://api.brownbook.net/businesses/reviews/{commentId}

Creates reply on a business comment.

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

$apiInstance = new Swagger\Client\Api\BusinessesApi(
    // If you want use custom http client, pass your client which implements `GuzzleHttp\ClientInterface`.
    // This is optional, `GuzzleHttp\Client` will be used as default.
    new GuzzleHttp\Client()
);
$comment_id = "comment_id_example"; // string | 
$message = "message_example"; // string | 
$business_id = 56; // int | Creates verification if comment reply belongs to business
$authorization = "Bearer {token}"; // string | 

try {
    $result = $apiInstance->postBusinessReply($comment_id, $message, $business_id, $authorization);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling BusinessesApi->postBusinessReply: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **comment_id** | **string**|  |
 **message** | **string**|  |
 **business_id** | **int**| Creates verification if comment reply belongs to business |
 **authorization** | **string**|  | [optional] [default to Bearer {token}]

### Return type

[**\Swagger\Client\Model\ReplyResponse[]**](../Model/ReplyResponse.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **postBusinesses**
> \Swagger\Client\Model\BusinessCreated200 postBusinesses($body, $authorization, $accept, $content_type)

https://api.brownbook.net/businesses/

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

$apiInstance = new Swagger\Client\Api\BusinessesApi(
    // If you want use custom http client, pass your client which implements `GuzzleHttp\ClientInterface`.
    // This is optional, `GuzzleHttp\Client` will be used as default.
    new GuzzleHttp\Client()
);
$body = new \Swagger\Client\Model\BusinessDetails(); // \Swagger\Client\Model\BusinessDetails | JSON string
$authorization = "Bearer {token}"; // string | 
$accept = "accept_example"; // string | 
$content_type = "content_type_example"; // string | 

try {
    $result = $apiInstance->postBusinesses($body, $authorization, $accept, $content_type);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling BusinessesApi->postBusinesses: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**\Swagger\Client\Model\BusinessDetails**](../Model/BusinessDetails.md)| JSON string |
 **authorization** | **string**|  | [optional] [default to Bearer {token}]
 **accept** | **string**|  | [optional]
 **content_type** | **string**|  | [optional]

### Return type

[**\Swagger\Client\Model\BusinessCreated200**](../Model/BusinessCreated200.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **unclaimBusiness**
> unclaimBusiness($business_id, $authorization)

https://api.brownbook.net/businesses/unclaim/{businessId}

Unclaim a business and removed extended content.

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

$apiInstance = new Swagger\Client\Api\BusinessesApi(
    // If you want use custom http client, pass your client which implements `GuzzleHttp\ClientInterface`.
    // This is optional, `GuzzleHttp\Client` will be used as default.
    new GuzzleHttp\Client()
);
$business_id = "business_id_example"; // string | 
$authorization = "Bearer {token}"; // string | 

try {
    $apiInstance->unclaimBusiness($business_id, $authorization);
} catch (Exception $e) {
    echo 'Exception when calling BusinessesApi->unclaimBusiness: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **business_id** | **string**|  |
 **authorization** | **string**|  | [optional] [default to Bearer {token}]

### Return type

void (empty response body)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: Not defined

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **updateBusinessReply**
> \Swagger\Client\Model\ReplyEditedResponse[] updateBusinessReply($body, $reply_id, $authorization)

https://api.brownbook.net/businesses/reviews/{replyId}

Edits reply on a business comment.

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

$apiInstance = new Swagger\Client\Api\BusinessesApi(
    // If you want use custom http client, pass your client which implements `GuzzleHttp\ClientInterface`.
    // This is optional, `GuzzleHttp\Client` will be used as default.
    new GuzzleHttp\Client()
);
$body = new \Swagger\Client\Model\ReplyReplyIdBody(); // \Swagger\Client\Model\ReplyReplyIdBody | 
$reply_id = "reply_id_example"; // string | Id of reply
$authorization = "Bearer {token}"; // string | 

try {
    $result = $apiInstance->updateBusinessReply($body, $reply_id, $authorization);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling BusinessesApi->updateBusinessReply: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**\Swagger\Client\Model\ReplyReplyIdBody**](../Model/ReplyReplyIdBody.md)|  |
 **reply_id** | **string**| Id of reply |
 **authorization** | **string**|  | [optional] [default to Bearer {token}]

### Return type

[**\Swagger\Client\Model\ReplyEditedResponse[]**](../Model/ReplyEditedResponse.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **updatedBusiness**
> \Swagger\Client\Model\Business updatedBusiness($body, $business_id, $authorization)

https://api.brownbook.net/businesses/{businessId}

Edit a business

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

$apiInstance = new Swagger\Client\Api\BusinessesApi(
    // If you want use custom http client, pass your client which implements `GuzzleHttp\ClientInterface`.
    // This is optional, `GuzzleHttp\Client` will be used as default.
    new GuzzleHttp\Client()
);
$body = new \Swagger\Client\Model\BusinessDetailsWhenUpdate(); // \Swagger\Client\Model\BusinessDetailsWhenUpdate | Business details object
$business_id = "business_id_example"; // string | 
$authorization = "Bearer {token}"; // string | 

try {
    $result = $apiInstance->updatedBusiness($body, $business_id, $authorization);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling BusinessesApi->updatedBusiness: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**\Swagger\Client\Model\BusinessDetailsWhenUpdate**](../Model/BusinessDetailsWhenUpdate.md)| Business details object |
 **business_id** | **string**|  |
 **authorization** | **string**|  | [optional] [default to Bearer {token}]

### Return type

[**\Swagger\Client\Model\Business**](../Model/Business.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

