<?php
/**
 * BusinessesApi
 * PHP version 5
 *
 * @category Class
 * @package  Swagger\Client
 * @author   Swagger Codegen team
 * @link     https://github.com/swagger-api/swagger-codegen
 */

/**
 * Brownbook API
 *
 * REST API Brownbook
 *
 * OpenAPI spec version: 1.0
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 * Swagger Codegen version: 3.0.34
 */
/**
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen
 * Do not edit the class manually.
 */

namespace Swagger\Client\Api;

use GuzzleHttp\Client;
use GuzzleHttp\ClientInterface;
use GuzzleHttp\Exception\RequestException;
use GuzzleHttp\Psr7\MultipartStream;
use GuzzleHttp\Psr7\Request;
use GuzzleHttp\RequestOptions;
use Swagger\Client\ApiException;
use Swagger\Client\Configuration;
use Swagger\Client\HeaderSelector;
use Swagger\Client\ObjectSerializer;

/**
 * BusinessesApi Class Doc Comment
 *
 * @category Class
 * @package  Swagger\Client
 * @author   Swagger Codegen team
 * @link     https://github.com/swagger-api/swagger-codegen
 */
class BusinessesApi
{
    /**
     * @var ClientInterface
     */
    protected $client;

    /**
     * @var Configuration
     */
    protected $config;

    /**
     * @var HeaderSelector
     */
    protected $headerSelector;

    /**
     * @param ClientInterface $client
     * @param Configuration   $config
     * @param HeaderSelector  $selector
     */
    public function __construct(
        ClientInterface $client = null,
        Configuration $config = null,
        HeaderSelector $selector = null
    ) {
        $this->client = $client ?: new Client();
        $this->config = $config ?: new Configuration();
        $this->headerSelector = $selector ?: new HeaderSelector();
    }

    /**
     * @return Configuration
     */
    public function getConfig()
    {
        return $this->config;
    }

    /**
     * Operation deleteBusinessReply
     *
     * deleteBusinessReply
     *
     * @param  \Swagger\Client\Model\ReplyReplyIdBody1 $body body (required)
     * @param  string $reply_id reply_id (required)
     * @param  string $authorization authorization (optional, default to Bearer {token})
     *
     * @throws \Swagger\Client\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return \Swagger\Client\Model\ReplyDeleteResponse[]
     */
    public function deleteBusinessReply($body, $reply_id, $authorization = 'Bearer {token}')
    {
        list($response) = $this->deleteBusinessReplyWithHttpInfo($body, $reply_id, $authorization);
        return $response;
    }

    /**
     * Operation deleteBusinessReplyWithHttpInfo
     *
     * deleteBusinessReply
     *
     * @param  \Swagger\Client\Model\ReplyReplyIdBody1 $body (required)
     * @param  string $reply_id (required)
     * @param  string $authorization (optional, default to Bearer {token})
     *
     * @throws \Swagger\Client\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return array of \Swagger\Client\Model\ReplyDeleteResponse[], HTTP status code, HTTP response headers (array of strings)
     */
    public function deleteBusinessReplyWithHttpInfo($body, $reply_id, $authorization = 'Bearer {token}')
    {
        $returnType = '\Swagger\Client\Model\ReplyDeleteResponse[]';
        $request = $this->deleteBusinessReplyRequest($body, $reply_id, $authorization);

        try {
            $options = $this->createHttpClientOption();
            try {
                $response = $this->client->send($request, $options);
            } catch (RequestException $e) {
                throw new ApiException(
                    "[{$e->getCode()}] {$e->getMessage()}",
                    $e->getCode(),
                    $e->getResponse() ? $e->getResponse()->getHeaders() : null,
                    $e->getResponse() ? $e->getResponse()->getBody()->getContents() : null
                );
            }

            $statusCode = $response->getStatusCode();

            if ($statusCode < 200 || $statusCode > 299) {
                throw new ApiException(
                    sprintf(
                        '[%d] Error connecting to the API (%s)',
                        $statusCode,
                        $request->getUri()
                    ),
                    $statusCode,
                    $response->getHeaders(),
                    $response->getBody()
                );
            }

            $responseBody = $response->getBody();
            if ($returnType === '\SplFileObject') {
                $content = $responseBody; //stream goes to serializer
            } else {
                $content = $responseBody->getContents();
                if (!in_array($returnType, ['string','integer','bool'])) {
                    $content = json_decode($content);
                }
            }

            return [
                ObjectSerializer::deserialize($content, $returnType, []),
                $response->getStatusCode(),
                $response->getHeaders()
            ];

        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 200:
                    $data = ObjectSerializer::deserialize(
                        $e->getResponseBody(),
                        '\Swagger\Client\Model\ReplyDeleteResponse[]',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
                case 401:
                    $data = ObjectSerializer::deserialize(
                        $e->getResponseBody(),
                        '\Swagger\Client\Model\ReplyResponse401[]',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
                case 404:
                    $data = ObjectSerializer::deserialize(
                        $e->getResponseBody(),
                        '\Swagger\Client\Model\ReplyResponse404R[]',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
                case 405:
                    $data = ObjectSerializer::deserialize(
                        $e->getResponseBody(),
                        '\Swagger\Client\Model\ReplyEditedResponse400[]',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
            }
            throw $e;
        }
    }

    /**
     * Operation deleteBusinessReplyAsync
     *
     * deleteBusinessReply
     *
     * @param  \Swagger\Client\Model\ReplyReplyIdBody1 $body (required)
     * @param  string $reply_id (required)
     * @param  string $authorization (optional, default to Bearer {token})
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function deleteBusinessReplyAsync($body, $reply_id, $authorization = 'Bearer {token}')
    {
        return $this->deleteBusinessReplyAsyncWithHttpInfo($body, $reply_id, $authorization)
            ->then(
                function ($response) {
                    return $response[0];
                }
            );
    }

    /**
     * Operation deleteBusinessReplyAsyncWithHttpInfo
     *
     * deleteBusinessReply
     *
     * @param  \Swagger\Client\Model\ReplyReplyIdBody1 $body (required)
     * @param  string $reply_id (required)
     * @param  string $authorization (optional, default to Bearer {token})
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function deleteBusinessReplyAsyncWithHttpInfo($body, $reply_id, $authorization = 'Bearer {token}')
    {
        $returnType = '\Swagger\Client\Model\ReplyDeleteResponse[]';
        $request = $this->deleteBusinessReplyRequest($body, $reply_id, $authorization);

        return $this->client
            ->sendAsync($request, $this->createHttpClientOption())
            ->then(
                function ($response) use ($returnType) {
                    $responseBody = $response->getBody();
                    if ($returnType === '\SplFileObject') {
                        $content = $responseBody; //stream goes to serializer
                    } else {
                        $content = $responseBody->getContents();
                        if ($returnType !== 'string') {
                            $content = json_decode($content);
                        }
                    }

                    return [
                        ObjectSerializer::deserialize($content, $returnType, []),
                        $response->getStatusCode(),
                        $response->getHeaders()
                    ];
                },
                function ($exception) {
                    $response = $exception->getResponse();
                    $statusCode = $response->getStatusCode();
                    throw new ApiException(
                        sprintf(
                            '[%d] Error connecting to the API (%s)',
                            $statusCode,
                            $exception->getRequest()->getUri()
                        ),
                        $statusCode,
                        $response->getHeaders(),
                        $response->getBody()
                    );
                }
            );
    }

    /**
     * Create request for operation 'deleteBusinessReply'
     *
     * @param  \Swagger\Client\Model\ReplyReplyIdBody1 $body (required)
     * @param  string $reply_id (required)
     * @param  string $authorization (optional, default to Bearer {token})
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Psr7\Request
     */
    protected function deleteBusinessReplyRequest($body, $reply_id, $authorization = 'Bearer {token}')
    {
        // verify the required parameter 'body' is set
        if ($body === null || (is_array($body) && count($body) === 0)) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $body when calling deleteBusinessReply'
            );
        }
        // verify the required parameter 'reply_id' is set
        if ($reply_id === null || (is_array($reply_id) && count($reply_id) === 0)) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $reply_id when calling deleteBusinessReply'
            );
        }

        $resourcePath = '/businesses/reviews/reply/{replyId}';
        $formParams = [];
        $queryParams = [];
        $headerParams = [];
        $httpBody = '';
        $multipart = false;

        // header params
        if ($authorization !== null) {
            $headerParams['Authorization'] = ObjectSerializer::toHeaderValue($authorization);
        }

        // path params
        if ($reply_id !== null) {
            $resourcePath = str_replace(
                '{' . 'replyId' . '}',
                ObjectSerializer::toPathValue($reply_id),
                $resourcePath
            );
        }

        // body params
        $_tempBody = null;
        if (isset($body)) {
            $_tempBody = $body;
        }

        if ($multipart) {
            $headers = $this->headerSelector->selectHeadersForMultipart(
                ['application/json']
            );
        } else {
            $headers = $this->headerSelector->selectHeaders(
                ['application/json'],
                ['application/json']
            );
        }

        // for model (json/xml)
        if (isset($_tempBody)) {
            // $_tempBody is the method argument, if present
            $httpBody = $_tempBody;
            // \stdClass has no __toString(), so we should encode it manually
            if ($httpBody instanceof \stdClass && $headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode($httpBody);
            }
        } elseif (count($formParams) > 0) {
            if ($multipart) {
                $multipartContents = [];
                foreach ($formParams as $formParamName => $formParamValue) {
                    $multipartContents[] = [
                        'name' => $formParamName,
                        'contents' => $formParamValue
                    ];
                }
                // for HTTP post (form)
                $httpBody = new MultipartStream($multipartContents);

            } elseif ($headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode($formParams);

            } else {
                // for HTTP post (form)
                $httpBody = \GuzzleHttp\Psr7\build_query($formParams);
            }
        }


        $defaultHeaders = [];
        if ($this->config->getUserAgent()) {
            $defaultHeaders['User-Agent'] = $this->config->getUserAgent();
        }

        $headers = array_merge(
            $defaultHeaders,
            $headerParams,
            $headers
        );

        $query = \GuzzleHttp\Psr7\build_query($queryParams);
        return new Request(
            'DELETE',
            $this->config->getHost() . $resourcePath . ($query ? "?{$query}" : ''),
            $headers,
            $httpBody
        );
    }

    /**
     * Operation getBusiness
     *
     * https://api.brownbook.net/businesses/{businessId}
     *
     * @param  string $content_type content_type (required)
     * @param  string $accept accept (required)
     * @param  string $authorization authorization (optional, default to Bearer {token})
     *
     * @throws \Swagger\Client\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return \Swagger\Client\Model\BusinessDetails
     */
    public function getBusiness($content_type, $accept, $authorization = 'Bearer {token}')
    {
        list($response) = $this->getBusinessWithHttpInfo($content_type, $accept, $authorization);
        return $response;
    }

    /**
     * Operation getBusinessWithHttpInfo
     *
     * https://api.brownbook.net/businesses/{businessId}
     *
     * @param  string $content_type (required)
     * @param  string $accept (required)
     * @param  string $authorization (optional, default to Bearer {token})
     *
     * @throws \Swagger\Client\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return array of \Swagger\Client\Model\BusinessDetails, HTTP status code, HTTP response headers (array of strings)
     */
    public function getBusinessWithHttpInfo($content_type, $accept, $authorization = 'Bearer {token}')
    {
        $returnType = '\Swagger\Client\Model\BusinessDetails';
        $request = $this->getBusinessRequest($content_type, $accept, $authorization);

        try {
            $options = $this->createHttpClientOption();
            try {
                $response = $this->client->send($request, $options);
            } catch (RequestException $e) {
                throw new ApiException(
                    "[{$e->getCode()}] {$e->getMessage()}",
                    $e->getCode(),
                    $e->getResponse() ? $e->getResponse()->getHeaders() : null,
                    $e->getResponse() ? $e->getResponse()->getBody()->getContents() : null
                );
            }

            $statusCode = $response->getStatusCode();

            if ($statusCode < 200 || $statusCode > 299) {
                throw new ApiException(
                    sprintf(
                        '[%d] Error connecting to the API (%s)',
                        $statusCode,
                        $request->getUri()
                    ),
                    $statusCode,
                    $response->getHeaders(),
                    $response->getBody()
                );
            }

            $responseBody = $response->getBody();
            if ($returnType === '\SplFileObject') {
                $content = $responseBody; //stream goes to serializer
            } else {
                $content = $responseBody->getContents();
                if (!in_array($returnType, ['string','integer','bool'])) {
                    $content = json_decode($content);
                }
            }

            return [
                ObjectSerializer::deserialize($content, $returnType, []),
                $response->getStatusCode(),
                $response->getHeaders()
            ];

        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 200:
                    $data = ObjectSerializer::deserialize(
                        $e->getResponseBody(),
                        '\Swagger\Client\Model\BusinessDetails',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
                case 404:
                    $data = ObjectSerializer::deserialize(
                        $e->getResponseBody(),
                        '\Swagger\Client\Model\Business404NotFound',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
            }
            throw $e;
        }
    }

    /**
     * Operation getBusinessAsync
     *
     * https://api.brownbook.net/businesses/{businessId}
     *
     * @param  string $content_type (required)
     * @param  string $accept (required)
     * @param  string $authorization (optional, default to Bearer {token})
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function getBusinessAsync($content_type, $accept, $authorization = 'Bearer {token}')
    {
        return $this->getBusinessAsyncWithHttpInfo($content_type, $accept, $authorization)
            ->then(
                function ($response) {
                    return $response[0];
                }
            );
    }

    /**
     * Operation getBusinessAsyncWithHttpInfo
     *
     * https://api.brownbook.net/businesses/{businessId}
     *
     * @param  string $content_type (required)
     * @param  string $accept (required)
     * @param  string $authorization (optional, default to Bearer {token})
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function getBusinessAsyncWithHttpInfo($content_type, $accept, $authorization = 'Bearer {token}')
    {
        $returnType = '\Swagger\Client\Model\BusinessDetails';
        $request = $this->getBusinessRequest($content_type, $accept, $authorization);

        return $this->client
            ->sendAsync($request, $this->createHttpClientOption())
            ->then(
                function ($response) use ($returnType) {
                    $responseBody = $response->getBody();
                    if ($returnType === '\SplFileObject') {
                        $content = $responseBody; //stream goes to serializer
                    } else {
                        $content = $responseBody->getContents();
                        if ($returnType !== 'string') {
                            $content = json_decode($content);
                        }
                    }

                    return [
                        ObjectSerializer::deserialize($content, $returnType, []),
                        $response->getStatusCode(),
                        $response->getHeaders()
                    ];
                },
                function ($exception) {
                    $response = $exception->getResponse();
                    $statusCode = $response->getStatusCode();
                    throw new ApiException(
                        sprintf(
                            '[%d] Error connecting to the API (%s)',
                            $statusCode,
                            $exception->getRequest()->getUri()
                        ),
                        $statusCode,
                        $response->getHeaders(),
                        $response->getBody()
                    );
                }
            );
    }

    /**
     * Create request for operation 'getBusiness'
     *
     * @param  string $content_type (required)
     * @param  string $accept (required)
     * @param  string $authorization (optional, default to Bearer {token})
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Psr7\Request
     */
    protected function getBusinessRequest($content_type, $accept, $authorization = 'Bearer {token}')
    {
        // verify the required parameter 'content_type' is set
        if ($content_type === null || (is_array($content_type) && count($content_type) === 0)) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $content_type when calling getBusiness'
            );
        }
        // verify the required parameter 'accept' is set
        if ($accept === null || (is_array($accept) && count($accept) === 0)) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $accept when calling getBusiness'
            );
        }

        $resourcePath = '/businesses/{businessId}';
        $formParams = [];
        $queryParams = [];
        $headerParams = [];
        $httpBody = '';
        $multipart = false;

        // header params
        if ($authorization !== null) {
            $headerParams['Authorization'] = ObjectSerializer::toHeaderValue($authorization);
        }
        // header params
        if ($content_type !== null) {
            $headerParams['Content-Type'] = ObjectSerializer::toHeaderValue($content_type);
        }
        // header params
        if ($accept !== null) {
            $headerParams['Accept'] = ObjectSerializer::toHeaderValue($accept);
        }


        // body params
        $_tempBody = null;

        if ($multipart) {
            $headers = $this->headerSelector->selectHeadersForMultipart(
                ['application/json']
            );
        } else {
            $headers = $this->headerSelector->selectHeaders(
                ['application/json'],
                []
            );
        }

        // for model (json/xml)
        if (isset($_tempBody)) {
            // $_tempBody is the method argument, if present
            $httpBody = $_tempBody;
            // \stdClass has no __toString(), so we should encode it manually
            if ($httpBody instanceof \stdClass && $headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode($httpBody);
            }
        } elseif (count($formParams) > 0) {
            if ($multipart) {
                $multipartContents = [];
                foreach ($formParams as $formParamName => $formParamValue) {
                    $multipartContents[] = [
                        'name' => $formParamName,
                        'contents' => $formParamValue
                    ];
                }
                // for HTTP post (form)
                $httpBody = new MultipartStream($multipartContents);

            } elseif ($headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode($formParams);

            } else {
                // for HTTP post (form)
                $httpBody = \GuzzleHttp\Psr7\build_query($formParams);
            }
        }


        $defaultHeaders = [];
        if ($this->config->getUserAgent()) {
            $defaultHeaders['User-Agent'] = $this->config->getUserAgent();
        }

        $headers = array_merge(
            $defaultHeaders,
            $headerParams,
            $headers
        );

        $query = \GuzzleHttp\Psr7\build_query($queryParams);
        return new Request(
            'GET',
            $this->config->getHost() . $resourcePath . ($query ? "?{$query}" : ''),
            $headers,
            $httpBody
        );
    }

    /**
     * Operation getBusinessDupe
     *
     * https://api.brownbook.net/businesses/dupe/{businessId}
     *
     * @param  string $business_id business_id (required)
     * @param  string $authorization authorization (optional, default to Bearer {token})
     *
     * @throws \Swagger\Client\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return void
     */
    public function getBusinessDupe($business_id, $authorization = 'Bearer {token}')
    {
        $this->getBusinessDupeWithHttpInfo($business_id, $authorization);
    }

    /**
     * Operation getBusinessDupeWithHttpInfo
     *
     * https://api.brownbook.net/businesses/dupe/{businessId}
     *
     * @param  string $business_id (required)
     * @param  string $authorization (optional, default to Bearer {token})
     *
     * @throws \Swagger\Client\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return array of null, HTTP status code, HTTP response headers (array of strings)
     */
    public function getBusinessDupeWithHttpInfo($business_id, $authorization = 'Bearer {token}')
    {
        $returnType = '';
        $request = $this->getBusinessDupeRequest($business_id, $authorization);

        try {
            $options = $this->createHttpClientOption();
            try {
                $response = $this->client->send($request, $options);
            } catch (RequestException $e) {
                throw new ApiException(
                    "[{$e->getCode()}] {$e->getMessage()}",
                    $e->getCode(),
                    $e->getResponse() ? $e->getResponse()->getHeaders() : null,
                    $e->getResponse() ? $e->getResponse()->getBody()->getContents() : null
                );
            }

            $statusCode = $response->getStatusCode();

            if ($statusCode < 200 || $statusCode > 299) {
                throw new ApiException(
                    sprintf(
                        '[%d] Error connecting to the API (%s)',
                        $statusCode,
                        $request->getUri()
                    ),
                    $statusCode,
                    $response->getHeaders(),
                    $response->getBody()
                );
            }

            return [null, $statusCode, $response->getHeaders()];

        } catch (ApiException $e) {
            switch ($e->getCode()) {
            }
            throw $e;
        }
    }

    /**
     * Operation getBusinessDupeAsync
     *
     * https://api.brownbook.net/businesses/dupe/{businessId}
     *
     * @param  string $business_id (required)
     * @param  string $authorization (optional, default to Bearer {token})
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function getBusinessDupeAsync($business_id, $authorization = 'Bearer {token}')
    {
        return $this->getBusinessDupeAsyncWithHttpInfo($business_id, $authorization)
            ->then(
                function ($response) {
                    return $response[0];
                }
            );
    }

    /**
     * Operation getBusinessDupeAsyncWithHttpInfo
     *
     * https://api.brownbook.net/businesses/dupe/{businessId}
     *
     * @param  string $business_id (required)
     * @param  string $authorization (optional, default to Bearer {token})
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function getBusinessDupeAsyncWithHttpInfo($business_id, $authorization = 'Bearer {token}')
    {
        $returnType = '';
        $request = $this->getBusinessDupeRequest($business_id, $authorization);

        return $this->client
            ->sendAsync($request, $this->createHttpClientOption())
            ->then(
                function ($response) use ($returnType) {
                    return [null, $response->getStatusCode(), $response->getHeaders()];
                },
                function ($exception) {
                    $response = $exception->getResponse();
                    $statusCode = $response->getStatusCode();
                    throw new ApiException(
                        sprintf(
                            '[%d] Error connecting to the API (%s)',
                            $statusCode,
                            $exception->getRequest()->getUri()
                        ),
                        $statusCode,
                        $response->getHeaders(),
                        $response->getBody()
                    );
                }
            );
    }

    /**
     * Create request for operation 'getBusinessDupe'
     *
     * @param  string $business_id (required)
     * @param  string $authorization (optional, default to Bearer {token})
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Psr7\Request
     */
    protected function getBusinessDupeRequest($business_id, $authorization = 'Bearer {token}')
    {
        // verify the required parameter 'business_id' is set
        if ($business_id === null || (is_array($business_id) && count($business_id) === 0)) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $business_id when calling getBusinessDupe'
            );
        }

        $resourcePath = '/businesses/dupe/{businessId}';
        $formParams = [];
        $queryParams = [];
        $headerParams = [];
        $httpBody = '';
        $multipart = false;

        // header params
        if ($authorization !== null) {
            $headerParams['Authorization'] = ObjectSerializer::toHeaderValue($authorization);
        }

        // path params
        if ($business_id !== null) {
            $resourcePath = str_replace(
                '{' . 'businessId' . '}',
                ObjectSerializer::toPathValue($business_id),
                $resourcePath
            );
        }

        // body params
        $_tempBody = null;

        if ($multipart) {
            $headers = $this->headerSelector->selectHeadersForMultipart(
                ['application/json']
            );
        } else {
            $headers = $this->headerSelector->selectHeaders(
                ['application/json'],
                []
            );
        }

        // for model (json/xml)
        if (isset($_tempBody)) {
            // $_tempBody is the method argument, if present
            $httpBody = $_tempBody;
            // \stdClass has no __toString(), so we should encode it manually
            if ($httpBody instanceof \stdClass && $headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode($httpBody);
            }
        } elseif (count($formParams) > 0) {
            if ($multipart) {
                $multipartContents = [];
                foreach ($formParams as $formParamName => $formParamValue) {
                    $multipartContents[] = [
                        'name' => $formParamName,
                        'contents' => $formParamValue
                    ];
                }
                // for HTTP post (form)
                $httpBody = new MultipartStream($multipartContents);

            } elseif ($headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode($formParams);

            } else {
                // for HTTP post (form)
                $httpBody = \GuzzleHttp\Psr7\build_query($formParams);
            }
        }


        $defaultHeaders = [];
        if ($this->config->getUserAgent()) {
            $defaultHeaders['User-Agent'] = $this->config->getUserAgent();
        }

        $headers = array_merge(
            $defaultHeaders,
            $headerParams,
            $headers
        );

        $query = \GuzzleHttp\Psr7\build_query($queryParams);
        return new Request(
            'GET',
            $this->config->getHost() . $resourcePath . ($query ? "?{$query}" : ''),
            $headers,
            $httpBody
        );
    }

    /**
     * Operation getBusinesses
     *
     * https://api.brownbook.net/businesses/
     *
     * @param  string $country Specify country for filtering businesses (required) (US,CA,AU) (required)
     * @param  int $_limit Takes specified number of records (required)
     * @param  int $_offset Offset the results from this number (required)
     * @param  string $authorization authorization (optional, default to Bearer {token})
     * @param  string $content_type content_type (optional)
     * @param  string $accept accept (optional)
     *
     * @throws \Swagger\Client\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return \Swagger\Client\Model\BusinessMultiple[]
     */
    public function getBusinesses($country, $_limit, $_offset, $authorization = 'Bearer {token}', $content_type = null, $accept = null)
    {
        list($response) = $this->getBusinessesWithHttpInfo($country, $_limit, $_offset, $authorization, $content_type, $accept);
        return $response;
    }

    /**
     * Operation getBusinessesWithHttpInfo
     *
     * https://api.brownbook.net/businesses/
     *
     * @param  string $country Specify country for filtering businesses (required) (US,CA,AU) (required)
     * @param  int $_limit Takes specified number of records (required)
     * @param  int $_offset Offset the results from this number (required)
     * @param  string $authorization (optional, default to Bearer {token})
     * @param  string $content_type (optional)
     * @param  string $accept (optional)
     *
     * @throws \Swagger\Client\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return array of \Swagger\Client\Model\BusinessMultiple[], HTTP status code, HTTP response headers (array of strings)
     */
    public function getBusinessesWithHttpInfo($country, $_limit, $_offset, $authorization = 'Bearer {token}', $content_type = null, $accept = null)
    {
        $returnType = '\Swagger\Client\Model\BusinessMultiple[]';
        $request = $this->getBusinessesRequest($country, $_limit, $_offset, $authorization, $content_type, $accept);

        try {
            $options = $this->createHttpClientOption();
            try {
                $response = $this->client->send($request, $options);
            } catch (RequestException $e) {
                throw new ApiException(
                    "[{$e->getCode()}] {$e->getMessage()}",
                    $e->getCode(),
                    $e->getResponse() ? $e->getResponse()->getHeaders() : null,
                    $e->getResponse() ? $e->getResponse()->getBody()->getContents() : null
                );
            }

            $statusCode = $response->getStatusCode();

            if ($statusCode < 200 || $statusCode > 299) {
                throw new ApiException(
                    sprintf(
                        '[%d] Error connecting to the API (%s)',
                        $statusCode,
                        $request->getUri()
                    ),
                    $statusCode,
                    $response->getHeaders(),
                    $response->getBody()
                );
            }

            $responseBody = $response->getBody();
            if ($returnType === '\SplFileObject') {
                $content = $responseBody; //stream goes to serializer
            } else {
                $content = $responseBody->getContents();
                if (!in_array($returnType, ['string','integer','bool'])) {
                    $content = json_decode($content);
                }
            }

            return [
                ObjectSerializer::deserialize($content, $returnType, []),
                $response->getStatusCode(),
                $response->getHeaders()
            ];

        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 200:
                    $data = ObjectSerializer::deserialize(
                        $e->getResponseBody(),
                        '\Swagger\Client\Model\BusinessMultiple[]',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
            }
            throw $e;
        }
    }

    /**
     * Operation getBusinessesAsync
     *
     * https://api.brownbook.net/businesses/
     *
     * @param  string $country Specify country for filtering businesses (required) (US,CA,AU) (required)
     * @param  int $_limit Takes specified number of records (required)
     * @param  int $_offset Offset the results from this number (required)
     * @param  string $authorization (optional, default to Bearer {token})
     * @param  string $content_type (optional)
     * @param  string $accept (optional)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function getBusinessesAsync($country, $_limit, $_offset, $authorization = 'Bearer {token}', $content_type = null, $accept = null)
    {
        return $this->getBusinessesAsyncWithHttpInfo($country, $_limit, $_offset, $authorization, $content_type, $accept)
            ->then(
                function ($response) {
                    return $response[0];
                }
            );
    }

    /**
     * Operation getBusinessesAsyncWithHttpInfo
     *
     * https://api.brownbook.net/businesses/
     *
     * @param  string $country Specify country for filtering businesses (required) (US,CA,AU) (required)
     * @param  int $_limit Takes specified number of records (required)
     * @param  int $_offset Offset the results from this number (required)
     * @param  string $authorization (optional, default to Bearer {token})
     * @param  string $content_type (optional)
     * @param  string $accept (optional)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function getBusinessesAsyncWithHttpInfo($country, $_limit, $_offset, $authorization = 'Bearer {token}', $content_type = null, $accept = null)
    {
        $returnType = '\Swagger\Client\Model\BusinessMultiple[]';
        $request = $this->getBusinessesRequest($country, $_limit, $_offset, $authorization, $content_type, $accept);

        return $this->client
            ->sendAsync($request, $this->createHttpClientOption())
            ->then(
                function ($response) use ($returnType) {
                    $responseBody = $response->getBody();
                    if ($returnType === '\SplFileObject') {
                        $content = $responseBody; //stream goes to serializer
                    } else {
                        $content = $responseBody->getContents();
                        if ($returnType !== 'string') {
                            $content = json_decode($content);
                        }
                    }

                    return [
                        ObjectSerializer::deserialize($content, $returnType, []),
                        $response->getStatusCode(),
                        $response->getHeaders()
                    ];
                },
                function ($exception) {
                    $response = $exception->getResponse();
                    $statusCode = $response->getStatusCode();
                    throw new ApiException(
                        sprintf(
                            '[%d] Error connecting to the API (%s)',
                            $statusCode,
                            $exception->getRequest()->getUri()
                        ),
                        $statusCode,
                        $response->getHeaders(),
                        $response->getBody()
                    );
                }
            );
    }

    /**
     * Create request for operation 'getBusinesses'
     *
     * @param  string $country Specify country for filtering businesses (required) (US,CA,AU) (required)
     * @param  int $_limit Takes specified number of records (required)
     * @param  int $_offset Offset the results from this number (required)
     * @param  string $authorization (optional, default to Bearer {token})
     * @param  string $content_type (optional)
     * @param  string $accept (optional)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Psr7\Request
     */
    protected function getBusinessesRequest($country, $_limit, $_offset, $authorization = 'Bearer {token}', $content_type = null, $accept = null)
    {
        // verify the required parameter 'country' is set
        if ($country === null || (is_array($country) && count($country) === 0)) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $country when calling getBusinesses'
            );
        }
        // verify the required parameter '_limit' is set
        if ($_limit === null || (is_array($_limit) && count($_limit) === 0)) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $_limit when calling getBusinesses'
            );
        }
        // verify the required parameter '_offset' is set
        if ($_offset === null || (is_array($_offset) && count($_offset) === 0)) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $_offset when calling getBusinesses'
            );
        }

        $resourcePath = '/businesses';
        $formParams = [];
        $queryParams = [];
        $headerParams = [];
        $httpBody = '';
        $multipart = false;

        // query params
        if ($country !== null) {
            $queryParams['country'] = ObjectSerializer::toQueryValue($country, null);
        }
        // query params
        if ($_limit !== null) {
            $queryParams['_limit'] = ObjectSerializer::toQueryValue($_limit, 'int32');
        }
        // query params
        if ($_offset !== null) {
            $queryParams['_offset'] = ObjectSerializer::toQueryValue($_offset, 'int32');
        }
        // header params
        if ($authorization !== null) {
            $headerParams['Authorization'] = ObjectSerializer::toHeaderValue($authorization);
        }
        // header params
        if ($content_type !== null) {
            $headerParams['Content-Type'] = ObjectSerializer::toHeaderValue($content_type);
        }
        // header params
        if ($accept !== null) {
            $headerParams['Accept'] = ObjectSerializer::toHeaderValue($accept);
        }


        // body params
        $_tempBody = null;

        if ($multipart) {
            $headers = $this->headerSelector->selectHeadersForMultipart(
                ['application/json']
            );
        } else {
            $headers = $this->headerSelector->selectHeaders(
                ['application/json'],
                []
            );
        }

        // for model (json/xml)
        if (isset($_tempBody)) {
            // $_tempBody is the method argument, if present
            $httpBody = $_tempBody;
            // \stdClass has no __toString(), so we should encode it manually
            if ($httpBody instanceof \stdClass && $headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode($httpBody);
            }
        } elseif (count($formParams) > 0) {
            if ($multipart) {
                $multipartContents = [];
                foreach ($formParams as $formParamName => $formParamValue) {
                    $multipartContents[] = [
                        'name' => $formParamName,
                        'contents' => $formParamValue
                    ];
                }
                // for HTTP post (form)
                $httpBody = new MultipartStream($multipartContents);

            } elseif ($headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode($formParams);

            } else {
                // for HTTP post (form)
                $httpBody = \GuzzleHttp\Psr7\build_query($formParams);
            }
        }


        $defaultHeaders = [];
        if ($this->config->getUserAgent()) {
            $defaultHeaders['User-Agent'] = $this->config->getUserAgent();
        }

        $headers = array_merge(
            $defaultHeaders,
            $headerParams,
            $headers
        );

        $query = \GuzzleHttp\Psr7\build_query($queryParams);
        return new Request(
            'GET',
            $this->config->getHost() . $resourcePath . ($query ? "?{$query}" : ''),
            $headers,
            $httpBody
        );
    }

    /**
     * Operation getBusinessesReviews
     *
     * https://api.brownbook.net/businesses/reviews/
     *
     * @param  int $business_id brownbook business Id (required) (required)
     * @param  string $content_type content_type (required)
     * @param  string $accept accept (required)
     * @param  string $authorization authorization (optional, default to Bearer {token})
     * @param  int $num Page number (2 page will make an offset 1000 * 2 &#x3D; 2000, 1 by default) (optional)
     * @param  int $limit Result limit (1000 by default) (optional)
     * @param  int $page Page number parameter (optional)
     * @param  int $offset Offset parameter. If offset is filled and page is empty then page will be as ceil(($offset+$offset) / $num + 1). (optional)
     * @param  string $order_by Order parameter. By default created_at. Can be created_at, id, updated_at, rating (optional)
     * @param  string $sort_by Sort parameter. By default ascending (asc). Can have 2 stages - asc or desc (optional)
     *
     * @throws \Swagger\Client\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return \Swagger\Client\Model\Reviews200
     */
    public function getBusinessesReviews($business_id, $content_type, $accept, $authorization = 'Bearer {token}', $num = null, $limit = null, $page = null, $offset = null, $order_by = null, $sort_by = null)
    {
        list($response) = $this->getBusinessesReviewsWithHttpInfo($business_id, $content_type, $accept, $authorization, $num, $limit, $page, $offset, $order_by, $sort_by);
        return $response;
    }

    /**
     * Operation getBusinessesReviewsWithHttpInfo
     *
     * https://api.brownbook.net/businesses/reviews/
     *
     * @param  int $business_id brownbook business Id (required) (required)
     * @param  string $content_type (required)
     * @param  string $accept (required)
     * @param  string $authorization (optional, default to Bearer {token})
     * @param  int $num Page number (2 page will make an offset 1000 * 2 &#x3D; 2000, 1 by default) (optional)
     * @param  int $limit Result limit (1000 by default) (optional)
     * @param  int $page Page number parameter (optional)
     * @param  int $offset Offset parameter. If offset is filled and page is empty then page will be as ceil(($offset+$offset) / $num + 1). (optional)
     * @param  string $order_by Order parameter. By default created_at. Can be created_at, id, updated_at, rating (optional)
     * @param  string $sort_by Sort parameter. By default ascending (asc). Can have 2 stages - asc or desc (optional)
     *
     * @throws \Swagger\Client\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return array of \Swagger\Client\Model\Reviews200, HTTP status code, HTTP response headers (array of strings)
     */
    public function getBusinessesReviewsWithHttpInfo($business_id, $content_type, $accept, $authorization = 'Bearer {token}', $num = null, $limit = null, $page = null, $offset = null, $order_by = null, $sort_by = null)
    {
        $returnType = '\Swagger\Client\Model\Reviews200';
        $request = $this->getBusinessesReviewsRequest($business_id, $content_type, $accept, $authorization, $num, $limit, $page, $offset, $order_by, $sort_by);

        try {
            $options = $this->createHttpClientOption();
            try {
                $response = $this->client->send($request, $options);
            } catch (RequestException $e) {
                throw new ApiException(
                    "[{$e->getCode()}] {$e->getMessage()}",
                    $e->getCode(),
                    $e->getResponse() ? $e->getResponse()->getHeaders() : null,
                    $e->getResponse() ? $e->getResponse()->getBody()->getContents() : null
                );
            }

            $statusCode = $response->getStatusCode();

            if ($statusCode < 200 || $statusCode > 299) {
                throw new ApiException(
                    sprintf(
                        '[%d] Error connecting to the API (%s)',
                        $statusCode,
                        $request->getUri()
                    ),
                    $statusCode,
                    $response->getHeaders(),
                    $response->getBody()
                );
            }

            $responseBody = $response->getBody();
            if ($returnType === '\SplFileObject') {
                $content = $responseBody; //stream goes to serializer
            } else {
                $content = $responseBody->getContents();
                if (!in_array($returnType, ['string','integer','bool'])) {
                    $content = json_decode($content);
                }
            }

            return [
                ObjectSerializer::deserialize($content, $returnType, []),
                $response->getStatusCode(),
                $response->getHeaders()
            ];

        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 200:
                    $data = ObjectSerializer::deserialize(
                        $e->getResponseBody(),
                        '\Swagger\Client\Model\Reviews200',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
            }
            throw $e;
        }
    }

    /**
     * Operation getBusinessesReviewsAsync
     *
     * https://api.brownbook.net/businesses/reviews/
     *
     * @param  int $business_id brownbook business Id (required) (required)
     * @param  string $content_type (required)
     * @param  string $accept (required)
     * @param  string $authorization (optional, default to Bearer {token})
     * @param  int $num Page number (2 page will make an offset 1000 * 2 &#x3D; 2000, 1 by default) (optional)
     * @param  int $limit Result limit (1000 by default) (optional)
     * @param  int $page Page number parameter (optional)
     * @param  int $offset Offset parameter. If offset is filled and page is empty then page will be as ceil(($offset+$offset) / $num + 1). (optional)
     * @param  string $order_by Order parameter. By default created_at. Can be created_at, id, updated_at, rating (optional)
     * @param  string $sort_by Sort parameter. By default ascending (asc). Can have 2 stages - asc or desc (optional)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function getBusinessesReviewsAsync($business_id, $content_type, $accept, $authorization = 'Bearer {token}', $num = null, $limit = null, $page = null, $offset = null, $order_by = null, $sort_by = null)
    {
        return $this->getBusinessesReviewsAsyncWithHttpInfo($business_id, $content_type, $accept, $authorization, $num, $limit, $page, $offset, $order_by, $sort_by)
            ->then(
                function ($response) {
                    return $response[0];
                }
            );
    }

    /**
     * Operation getBusinessesReviewsAsyncWithHttpInfo
     *
     * https://api.brownbook.net/businesses/reviews/
     *
     * @param  int $business_id brownbook business Id (required) (required)
     * @param  string $content_type (required)
     * @param  string $accept (required)
     * @param  string $authorization (optional, default to Bearer {token})
     * @param  int $num Page number (2 page will make an offset 1000 * 2 &#x3D; 2000, 1 by default) (optional)
     * @param  int $limit Result limit (1000 by default) (optional)
     * @param  int $page Page number parameter (optional)
     * @param  int $offset Offset parameter. If offset is filled and page is empty then page will be as ceil(($offset+$offset) / $num + 1). (optional)
     * @param  string $order_by Order parameter. By default created_at. Can be created_at, id, updated_at, rating (optional)
     * @param  string $sort_by Sort parameter. By default ascending (asc). Can have 2 stages - asc or desc (optional)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function getBusinessesReviewsAsyncWithHttpInfo($business_id, $content_type, $accept, $authorization = 'Bearer {token}', $num = null, $limit = null, $page = null, $offset = null, $order_by = null, $sort_by = null)
    {
        $returnType = '\Swagger\Client\Model\Reviews200';
        $request = $this->getBusinessesReviewsRequest($business_id, $content_type, $accept, $authorization, $num, $limit, $page, $offset, $order_by, $sort_by);

        return $this->client
            ->sendAsync($request, $this->createHttpClientOption())
            ->then(
                function ($response) use ($returnType) {
                    $responseBody = $response->getBody();
                    if ($returnType === '\SplFileObject') {
                        $content = $responseBody; //stream goes to serializer
                    } else {
                        $content = $responseBody->getContents();
                        if ($returnType !== 'string') {
                            $content = json_decode($content);
                        }
                    }

                    return [
                        ObjectSerializer::deserialize($content, $returnType, []),
                        $response->getStatusCode(),
                        $response->getHeaders()
                    ];
                },
                function ($exception) {
                    $response = $exception->getResponse();
                    $statusCode = $response->getStatusCode();
                    throw new ApiException(
                        sprintf(
                            '[%d] Error connecting to the API (%s)',
                            $statusCode,
                            $exception->getRequest()->getUri()
                        ),
                        $statusCode,
                        $response->getHeaders(),
                        $response->getBody()
                    );
                }
            );
    }

    /**
     * Create request for operation 'getBusinessesReviews'
     *
     * @param  int $business_id brownbook business Id (required) (required)
     * @param  string $content_type (required)
     * @param  string $accept (required)
     * @param  string $authorization (optional, default to Bearer {token})
     * @param  int $num Page number (2 page will make an offset 1000 * 2 &#x3D; 2000, 1 by default) (optional)
     * @param  int $limit Result limit (1000 by default) (optional)
     * @param  int $page Page number parameter (optional)
     * @param  int $offset Offset parameter. If offset is filled and page is empty then page will be as ceil(($offset+$offset) / $num + 1). (optional)
     * @param  string $order_by Order parameter. By default created_at. Can be created_at, id, updated_at, rating (optional)
     * @param  string $sort_by Sort parameter. By default ascending (asc). Can have 2 stages - asc or desc (optional)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Psr7\Request
     */
    protected function getBusinessesReviewsRequest($business_id, $content_type, $accept, $authorization = 'Bearer {token}', $num = null, $limit = null, $page = null, $offset = null, $order_by = null, $sort_by = null)
    {
        // verify the required parameter 'business_id' is set
        if ($business_id === null || (is_array($business_id) && count($business_id) === 0)) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $business_id when calling getBusinessesReviews'
            );
        }
        // verify the required parameter 'content_type' is set
        if ($content_type === null || (is_array($content_type) && count($content_type) === 0)) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $content_type when calling getBusinessesReviews'
            );
        }
        // verify the required parameter 'accept' is set
        if ($accept === null || (is_array($accept) && count($accept) === 0)) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $accept when calling getBusinessesReviews'
            );
        }

        $resourcePath = '/businesses/reviews';
        $formParams = [];
        $queryParams = [];
        $headerParams = [];
        $httpBody = '';
        $multipart = false;

        // query params
        if ($business_id !== null) {
            $queryParams['businessId'] = ObjectSerializer::toQueryValue($business_id, 'int32');
        }
        // query params
        if ($num !== null) {
            $queryParams['num'] = ObjectSerializer::toQueryValue($num, null);
        }
        // query params
        if ($limit !== null) {
            $queryParams['limit'] = ObjectSerializer::toQueryValue($limit, null);
        }
        // query params
        if ($page !== null) {
            $queryParams['page'] = ObjectSerializer::toQueryValue($page, null);
        }
        // query params
        if ($offset !== null) {
            $queryParams['offset'] = ObjectSerializer::toQueryValue($offset, null);
        }
        // query params
        if ($order_by !== null) {
            $queryParams['orderBy'] = ObjectSerializer::toQueryValue($order_by, null);
        }
        // query params
        if ($sort_by !== null) {
            $queryParams['sortBy'] = ObjectSerializer::toQueryValue($sort_by, null);
        }
        // header params
        if ($authorization !== null) {
            $headerParams['Authorization'] = ObjectSerializer::toHeaderValue($authorization);
        }
        // header params
        if ($content_type !== null) {
            $headerParams['Content-Type'] = ObjectSerializer::toHeaderValue($content_type);
        }
        // header params
        if ($accept !== null) {
            $headerParams['Accept'] = ObjectSerializer::toHeaderValue($accept);
        }


        // body params
        $_tempBody = null;

        if ($multipart) {
            $headers = $this->headerSelector->selectHeadersForMultipart(
                ['application/json']
            );
        } else {
            $headers = $this->headerSelector->selectHeaders(
                ['application/json'],
                []
            );
        }

        // for model (json/xml)
        if (isset($_tempBody)) {
            // $_tempBody is the method argument, if present
            $httpBody = $_tempBody;
            // \stdClass has no __toString(), so we should encode it manually
            if ($httpBody instanceof \stdClass && $headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode($httpBody);
            }
        } elseif (count($formParams) > 0) {
            if ($multipart) {
                $multipartContents = [];
                foreach ($formParams as $formParamName => $formParamValue) {
                    $multipartContents[] = [
                        'name' => $formParamName,
                        'contents' => $formParamValue
                    ];
                }
                // for HTTP post (form)
                $httpBody = new MultipartStream($multipartContents);

            } elseif ($headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode($formParams);

            } else {
                // for HTTP post (form)
                $httpBody = \GuzzleHttp\Psr7\build_query($formParams);
            }
        }


        $defaultHeaders = [];
        if ($this->config->getUserAgent()) {
            $defaultHeaders['User-Agent'] = $this->config->getUserAgent();
        }

        $headers = array_merge(
            $defaultHeaders,
            $headerParams,
            $headers
        );

        $query = \GuzzleHttp\Psr7\build_query($queryParams);
        return new Request(
            'GET',
            $this->config->getHost() . $resourcePath . ($query ? "?{$query}" : ''),
            $headers,
            $httpBody
        );
    }

    /**
     * Operation postBusinessReply
     *
     * https://api.brownbook.net/businesses/reviews/{commentId}
     *
     * @param  string $comment_id comment_id (required)
     * @param  string $message message (required)
     * @param  int $business_id Creates verification if comment reply belongs to business (required)
     * @param  string $authorization authorization (optional, default to Bearer {token})
     *
     * @throws \Swagger\Client\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return \Swagger\Client\Model\ReplyResponse[]
     */
    public function postBusinessReply($comment_id, $message, $business_id, $authorization = 'Bearer {token}')
    {
        list($response) = $this->postBusinessReplyWithHttpInfo($comment_id, $message, $business_id, $authorization);
        return $response;
    }

    /**
     * Operation postBusinessReplyWithHttpInfo
     *
     * https://api.brownbook.net/businesses/reviews/{commentId}
     *
     * @param  string $comment_id (required)
     * @param  string $message (required)
     * @param  int $business_id Creates verification if comment reply belongs to business (required)
     * @param  string $authorization (optional, default to Bearer {token})
     *
     * @throws \Swagger\Client\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return array of \Swagger\Client\Model\ReplyResponse[], HTTP status code, HTTP response headers (array of strings)
     */
    public function postBusinessReplyWithHttpInfo($comment_id, $message, $business_id, $authorization = 'Bearer {token}')
    {
        $returnType = '\Swagger\Client\Model\ReplyResponse[]';
        $request = $this->postBusinessReplyRequest($comment_id, $message, $business_id, $authorization);

        try {
            $options = $this->createHttpClientOption();
            try {
                $response = $this->client->send($request, $options);
            } catch (RequestException $e) {
                throw new ApiException(
                    "[{$e->getCode()}] {$e->getMessage()}",
                    $e->getCode(),
                    $e->getResponse() ? $e->getResponse()->getHeaders() : null,
                    $e->getResponse() ? $e->getResponse()->getBody()->getContents() : null
                );
            }

            $statusCode = $response->getStatusCode();

            if ($statusCode < 200 || $statusCode > 299) {
                throw new ApiException(
                    sprintf(
                        '[%d] Error connecting to the API (%s)',
                        $statusCode,
                        $request->getUri()
                    ),
                    $statusCode,
                    $response->getHeaders(),
                    $response->getBody()
                );
            }

            $responseBody = $response->getBody();
            if ($returnType === '\SplFileObject') {
                $content = $responseBody; //stream goes to serializer
            } else {
                $content = $responseBody->getContents();
                if (!in_array($returnType, ['string','integer','bool'])) {
                    $content = json_decode($content);
                }
            }

            return [
                ObjectSerializer::deserialize($content, $returnType, []),
                $response->getStatusCode(),
                $response->getHeaders()
            ];

        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 200:
                    $data = ObjectSerializer::deserialize(
                        $e->getResponseBody(),
                        '\Swagger\Client\Model\ReplyResponse[]',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
                case 401:
                    $data = ObjectSerializer::deserialize(
                        $e->getResponseBody(),
                        '\Swagger\Client\Model\ReplyResponse401[]',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
                case 402:
                    $data = ObjectSerializer::deserialize(
                        $e->getResponseBody(),
                        '\Swagger\Client\Model\ReplyResponse400[]',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
                case 404:
                    $data = ObjectSerializer::deserialize(
                        $e->getResponseBody(),
                        '\Swagger\Client\Model\ReplyResponse404[]',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
                case 406:
                    $data = ObjectSerializer::deserialize(
                        $e->getResponseBody(),
                        '\Swagger\Client\Model\ReplyAlreadyCreatedResponse[]',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
            }
            throw $e;
        }
    }

    /**
     * Operation postBusinessReplyAsync
     *
     * https://api.brownbook.net/businesses/reviews/{commentId}
     *
     * @param  string $comment_id (required)
     * @param  string $message (required)
     * @param  int $business_id Creates verification if comment reply belongs to business (required)
     * @param  string $authorization (optional, default to Bearer {token})
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function postBusinessReplyAsync($comment_id, $message, $business_id, $authorization = 'Bearer {token}')
    {
        return $this->postBusinessReplyAsyncWithHttpInfo($comment_id, $message, $business_id, $authorization)
            ->then(
                function ($response) {
                    return $response[0];
                }
            );
    }

    /**
     * Operation postBusinessReplyAsyncWithHttpInfo
     *
     * https://api.brownbook.net/businesses/reviews/{commentId}
     *
     * @param  string $comment_id (required)
     * @param  string $message (required)
     * @param  int $business_id Creates verification if comment reply belongs to business (required)
     * @param  string $authorization (optional, default to Bearer {token})
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function postBusinessReplyAsyncWithHttpInfo($comment_id, $message, $business_id, $authorization = 'Bearer {token}')
    {
        $returnType = '\Swagger\Client\Model\ReplyResponse[]';
        $request = $this->postBusinessReplyRequest($comment_id, $message, $business_id, $authorization);

        return $this->client
            ->sendAsync($request, $this->createHttpClientOption())
            ->then(
                function ($response) use ($returnType) {
                    $responseBody = $response->getBody();
                    if ($returnType === '\SplFileObject') {
                        $content = $responseBody; //stream goes to serializer
                    } else {
                        $content = $responseBody->getContents();
                        if ($returnType !== 'string') {
                            $content = json_decode($content);
                        }
                    }

                    return [
                        ObjectSerializer::deserialize($content, $returnType, []),
                        $response->getStatusCode(),
                        $response->getHeaders()
                    ];
                },
                function ($exception) {
                    $response = $exception->getResponse();
                    $statusCode = $response->getStatusCode();
                    throw new ApiException(
                        sprintf(
                            '[%d] Error connecting to the API (%s)',
                            $statusCode,
                            $exception->getRequest()->getUri()
                        ),
                        $statusCode,
                        $response->getHeaders(),
                        $response->getBody()
                    );
                }
            );
    }

    /**
     * Create request for operation 'postBusinessReply'
     *
     * @param  string $comment_id (required)
     * @param  string $message (required)
     * @param  int $business_id Creates verification if comment reply belongs to business (required)
     * @param  string $authorization (optional, default to Bearer {token})
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Psr7\Request
     */
    protected function postBusinessReplyRequest($comment_id, $message, $business_id, $authorization = 'Bearer {token}')
    {
        // verify the required parameter 'comment_id' is set
        if ($comment_id === null || (is_array($comment_id) && count($comment_id) === 0)) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $comment_id when calling postBusinessReply'
            );
        }
        // verify the required parameter 'message' is set
        if ($message === null || (is_array($message) && count($message) === 0)) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $message when calling postBusinessReply'
            );
        }
        // verify the required parameter 'business_id' is set
        if ($business_id === null || (is_array($business_id) && count($business_id) === 0)) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $business_id when calling postBusinessReply'
            );
        }

        $resourcePath = '/businesses/reviews/reply/{commentId}';
        $formParams = [];
        $queryParams = [];
        $headerParams = [];
        $httpBody = '';
        $multipart = false;

        // query params
        if ($message !== null) {
            $queryParams['message'] = ObjectSerializer::toQueryValue($message, null);
        }
        // query params
        if ($business_id !== null) {
            $queryParams['business_id'] = ObjectSerializer::toQueryValue($business_id, null);
        }
        // header params
        if ($authorization !== null) {
            $headerParams['Authorization'] = ObjectSerializer::toHeaderValue($authorization);
        }

        // path params
        if ($comment_id !== null) {
            $resourcePath = str_replace(
                '{' . 'commentId' . '}',
                ObjectSerializer::toPathValue($comment_id),
                $resourcePath
            );
        }

        // body params
        $_tempBody = null;

        if ($multipart) {
            $headers = $this->headerSelector->selectHeadersForMultipart(
                ['application/json']
            );
        } else {
            $headers = $this->headerSelector->selectHeaders(
                ['application/json'],
                []
            );
        }

        // for model (json/xml)
        if (isset($_tempBody)) {
            // $_tempBody is the method argument, if present
            $httpBody = $_tempBody;
            // \stdClass has no __toString(), so we should encode it manually
            if ($httpBody instanceof \stdClass && $headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode($httpBody);
            }
        } elseif (count($formParams) > 0) {
            if ($multipart) {
                $multipartContents = [];
                foreach ($formParams as $formParamName => $formParamValue) {
                    $multipartContents[] = [
                        'name' => $formParamName,
                        'contents' => $formParamValue
                    ];
                }
                // for HTTP post (form)
                $httpBody = new MultipartStream($multipartContents);

            } elseif ($headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode($formParams);

            } else {
                // for HTTP post (form)
                $httpBody = \GuzzleHttp\Psr7\build_query($formParams);
            }
        }


        $defaultHeaders = [];
        if ($this->config->getUserAgent()) {
            $defaultHeaders['User-Agent'] = $this->config->getUserAgent();
        }

        $headers = array_merge(
            $defaultHeaders,
            $headerParams,
            $headers
        );

        $query = \GuzzleHttp\Psr7\build_query($queryParams);
        return new Request(
            'PUT',
            $this->config->getHost() . $resourcePath . ($query ? "?{$query}" : ''),
            $headers,
            $httpBody
        );
    }

    /**
     * Operation postBusinesses
     *
     * https://api.brownbook.net/businesses/
     *
     * @param  \Swagger\Client\Model\BusinessDetails $body JSON string (required)
     * @param  string $authorization authorization (optional, default to Bearer {token})
     * @param  string $accept accept (optional)
     * @param  string $content_type content_type (optional)
     *
     * @throws \Swagger\Client\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return \Swagger\Client\Model\BusinessCreated200
     */
    public function postBusinesses($body, $authorization = 'Bearer {token}', $accept = null, $content_type = null)
    {
        list($response) = $this->postBusinessesWithHttpInfo($body, $authorization, $accept, $content_type);
        return $response;
    }

    /**
     * Operation postBusinessesWithHttpInfo
     *
     * https://api.brownbook.net/businesses/
     *
     * @param  \Swagger\Client\Model\BusinessDetails $body JSON string (required)
     * @param  string $authorization (optional, default to Bearer {token})
     * @param  string $accept (optional)
     * @param  string $content_type (optional)
     *
     * @throws \Swagger\Client\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return array of \Swagger\Client\Model\BusinessCreated200, HTTP status code, HTTP response headers (array of strings)
     */
    public function postBusinessesWithHttpInfo($body, $authorization = 'Bearer {token}', $accept = null, $content_type = null)
    {
        $returnType = '\Swagger\Client\Model\BusinessCreated200';
        $request = $this->postBusinessesRequest($body, $authorization, $accept, $content_type);

        try {
            $options = $this->createHttpClientOption();
            try {
                $response = $this->client->send($request, $options);
            } catch (RequestException $e) {
                throw new ApiException(
                    "[{$e->getCode()}] {$e->getMessage()}",
                    $e->getCode(),
                    $e->getResponse() ? $e->getResponse()->getHeaders() : null,
                    $e->getResponse() ? $e->getResponse()->getBody()->getContents() : null
                );
            }

            $statusCode = $response->getStatusCode();

            if ($statusCode < 200 || $statusCode > 299) {
                throw new ApiException(
                    sprintf(
                        '[%d] Error connecting to the API (%s)',
                        $statusCode,
                        $request->getUri()
                    ),
                    $statusCode,
                    $response->getHeaders(),
                    $response->getBody()
                );
            }

            $responseBody = $response->getBody();
            if ($returnType === '\SplFileObject') {
                $content = $responseBody; //stream goes to serializer
            } else {
                $content = $responseBody->getContents();
                if (!in_array($returnType, ['string','integer','bool'])) {
                    $content = json_decode($content);
                }
            }

            return [
                ObjectSerializer::deserialize($content, $returnType, []),
                $response->getStatusCode(),
                $response->getHeaders()
            ];

        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 200:
                    $data = ObjectSerializer::deserialize(
                        $e->getResponseBody(),
                        '\Swagger\Client\Model\BusinessCreated200',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
                case 400:
                    $data = ObjectSerializer::deserialize(
                        $e->getResponseBody(),
                        '\Swagger\Client\Model\BusinessSchemaError',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
                case 402:
                    $data = ObjectSerializer::deserialize(
                        $e->getResponseBody(),
                        '\Swagger\Client\Model\TokenExpired',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
                case 405:
                    $data = ObjectSerializer::deserialize(
                        $e->getResponseBody(),
                        '\Swagger\Client\Model\BusinessCreatingError',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
                case 500:
                    $data = ObjectSerializer::deserialize(
                        $e->getResponseBody(),
                        '\Swagger\Client\Model\Business500Error',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
            }
            throw $e;
        }
    }

    /**
     * Operation postBusinessesAsync
     *
     * https://api.brownbook.net/businesses/
     *
     * @param  \Swagger\Client\Model\BusinessDetails $body JSON string (required)
     * @param  string $authorization (optional, default to Bearer {token})
     * @param  string $accept (optional)
     * @param  string $content_type (optional)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function postBusinessesAsync($body, $authorization = 'Bearer {token}', $accept = null, $content_type = null)
    {
        return $this->postBusinessesAsyncWithHttpInfo($body, $authorization, $accept, $content_type)
            ->then(
                function ($response) {
                    return $response[0];
                }
            );
    }

    /**
     * Operation postBusinessesAsyncWithHttpInfo
     *
     * https://api.brownbook.net/businesses/
     *
     * @param  \Swagger\Client\Model\BusinessDetails $body JSON string (required)
     * @param  string $authorization (optional, default to Bearer {token})
     * @param  string $accept (optional)
     * @param  string $content_type (optional)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function postBusinessesAsyncWithHttpInfo($body, $authorization = 'Bearer {token}', $accept = null, $content_type = null)
    {
        $returnType = '\Swagger\Client\Model\BusinessCreated200';
        $request = $this->postBusinessesRequest($body, $authorization, $accept, $content_type);

        return $this->client
            ->sendAsync($request, $this->createHttpClientOption())
            ->then(
                function ($response) use ($returnType) {
                    $responseBody = $response->getBody();
                    if ($returnType === '\SplFileObject') {
                        $content = $responseBody; //stream goes to serializer
                    } else {
                        $content = $responseBody->getContents();
                        if ($returnType !== 'string') {
                            $content = json_decode($content);
                        }
                    }

                    return [
                        ObjectSerializer::deserialize($content, $returnType, []),
                        $response->getStatusCode(),
                        $response->getHeaders()
                    ];
                },
                function ($exception) {
                    $response = $exception->getResponse();
                    $statusCode = $response->getStatusCode();
                    throw new ApiException(
                        sprintf(
                            '[%d] Error connecting to the API (%s)',
                            $statusCode,
                            $exception->getRequest()->getUri()
                        ),
                        $statusCode,
                        $response->getHeaders(),
                        $response->getBody()
                    );
                }
            );
    }

    /**
     * Create request for operation 'postBusinesses'
     *
     * @param  \Swagger\Client\Model\BusinessDetails $body JSON string (required)
     * @param  string $authorization (optional, default to Bearer {token})
     * @param  string $accept (optional)
     * @param  string $content_type (optional)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Psr7\Request
     */
    protected function postBusinessesRequest($body, $authorization = 'Bearer {token}', $accept = null, $content_type = null)
    {
        // verify the required parameter 'body' is set
        if ($body === null || (is_array($body) && count($body) === 0)) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $body when calling postBusinesses'
            );
        }

        $resourcePath = '/businesses';
        $formParams = [];
        $queryParams = [];
        $headerParams = [];
        $httpBody = '';
        $multipart = false;

        // header params
        if ($authorization !== null) {
            $headerParams['Authorization'] = ObjectSerializer::toHeaderValue($authorization);
        }
        // header params
        if ($accept !== null) {
            $headerParams['Accept'] = ObjectSerializer::toHeaderValue($accept);
        }
        // header params
        if ($content_type !== null) {
            $headerParams['Content-Type'] = ObjectSerializer::toHeaderValue($content_type);
        }


        // body params
        $_tempBody = null;
        if (isset($body)) {
            $_tempBody = $body;
        }

        if ($multipart) {
            $headers = $this->headerSelector->selectHeadersForMultipart(
                ['application/json']
            );
        } else {
            $headers = $this->headerSelector->selectHeaders(
                ['application/json'],
                ['application/json']
            );
        }

        // for model (json/xml)
        if (isset($_tempBody)) {
            // $_tempBody is the method argument, if present
            $httpBody = $_tempBody;
            // \stdClass has no __toString(), so we should encode it manually
            if ($httpBody instanceof \stdClass && $headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode($httpBody);
            }
        } elseif (count($formParams) > 0) {
            if ($multipart) {
                $multipartContents = [];
                foreach ($formParams as $formParamName => $formParamValue) {
                    $multipartContents[] = [
                        'name' => $formParamName,
                        'contents' => $formParamValue
                    ];
                }
                // for HTTP post (form)
                $httpBody = new MultipartStream($multipartContents);

            } elseif ($headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode($formParams);

            } else {
                // for HTTP post (form)
                $httpBody = \GuzzleHttp\Psr7\build_query($formParams);
            }
        }


        $defaultHeaders = [];
        if ($this->config->getUserAgent()) {
            $defaultHeaders['User-Agent'] = $this->config->getUserAgent();
        }

        $headers = array_merge(
            $defaultHeaders,
            $headerParams,
            $headers
        );

        $query = \GuzzleHttp\Psr7\build_query($queryParams);
        return new Request(
            'POST',
            $this->config->getHost() . $resourcePath . ($query ? "?{$query}" : ''),
            $headers,
            $httpBody
        );
    }

    /**
     * Operation unclaimBusiness
     *
     * https://api.brownbook.net/businesses/unclaim/{businessId}
     *
     * @param  string $business_id business_id (required)
     * @param  string $authorization authorization (optional, default to Bearer {token})
     *
     * @throws \Swagger\Client\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return void
     */
    public function unclaimBusiness($business_id, $authorization = 'Bearer {token}')
    {
        $this->unclaimBusinessWithHttpInfo($business_id, $authorization);
    }

    /**
     * Operation unclaimBusinessWithHttpInfo
     *
     * https://api.brownbook.net/businesses/unclaim/{businessId}
     *
     * @param  string $business_id (required)
     * @param  string $authorization (optional, default to Bearer {token})
     *
     * @throws \Swagger\Client\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return array of null, HTTP status code, HTTP response headers (array of strings)
     */
    public function unclaimBusinessWithHttpInfo($business_id, $authorization = 'Bearer {token}')
    {
        $returnType = '';
        $request = $this->unclaimBusinessRequest($business_id, $authorization);

        try {
            $options = $this->createHttpClientOption();
            try {
                $response = $this->client->send($request, $options);
            } catch (RequestException $e) {
                throw new ApiException(
                    "[{$e->getCode()}] {$e->getMessage()}",
                    $e->getCode(),
                    $e->getResponse() ? $e->getResponse()->getHeaders() : null,
                    $e->getResponse() ? $e->getResponse()->getBody()->getContents() : null
                );
            }

            $statusCode = $response->getStatusCode();

            if ($statusCode < 200 || $statusCode > 299) {
                throw new ApiException(
                    sprintf(
                        '[%d] Error connecting to the API (%s)',
                        $statusCode,
                        $request->getUri()
                    ),
                    $statusCode,
                    $response->getHeaders(),
                    $response->getBody()
                );
            }

            return [null, $statusCode, $response->getHeaders()];

        } catch (ApiException $e) {
            switch ($e->getCode()) {
            }
            throw $e;
        }
    }

    /**
     * Operation unclaimBusinessAsync
     *
     * https://api.brownbook.net/businesses/unclaim/{businessId}
     *
     * @param  string $business_id (required)
     * @param  string $authorization (optional, default to Bearer {token})
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function unclaimBusinessAsync($business_id, $authorization = 'Bearer {token}')
    {
        return $this->unclaimBusinessAsyncWithHttpInfo($business_id, $authorization)
            ->then(
                function ($response) {
                    return $response[0];
                }
            );
    }

    /**
     * Operation unclaimBusinessAsyncWithHttpInfo
     *
     * https://api.brownbook.net/businesses/unclaim/{businessId}
     *
     * @param  string $business_id (required)
     * @param  string $authorization (optional, default to Bearer {token})
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function unclaimBusinessAsyncWithHttpInfo($business_id, $authorization = 'Bearer {token}')
    {
        $returnType = '';
        $request = $this->unclaimBusinessRequest($business_id, $authorization);

        return $this->client
            ->sendAsync($request, $this->createHttpClientOption())
            ->then(
                function ($response) use ($returnType) {
                    return [null, $response->getStatusCode(), $response->getHeaders()];
                },
                function ($exception) {
                    $response = $exception->getResponse();
                    $statusCode = $response->getStatusCode();
                    throw new ApiException(
                        sprintf(
                            '[%d] Error connecting to the API (%s)',
                            $statusCode,
                            $exception->getRequest()->getUri()
                        ),
                        $statusCode,
                        $response->getHeaders(),
                        $response->getBody()
                    );
                }
            );
    }

    /**
     * Create request for operation 'unclaimBusiness'
     *
     * @param  string $business_id (required)
     * @param  string $authorization (optional, default to Bearer {token})
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Psr7\Request
     */
    protected function unclaimBusinessRequest($business_id, $authorization = 'Bearer {token}')
    {
        // verify the required parameter 'business_id' is set
        if ($business_id === null || (is_array($business_id) && count($business_id) === 0)) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $business_id when calling unclaimBusiness'
            );
        }

        $resourcePath = '/businesses/unclaim/{businessId}';
        $formParams = [];
        $queryParams = [];
        $headerParams = [];
        $httpBody = '';
        $multipart = false;

        // header params
        if ($authorization !== null) {
            $headerParams['Authorization'] = ObjectSerializer::toHeaderValue($authorization);
        }

        // path params
        if ($business_id !== null) {
            $resourcePath = str_replace(
                '{' . 'businessId' . '}',
                ObjectSerializer::toPathValue($business_id),
                $resourcePath
            );
        }

        // body params
        $_tempBody = null;

        if ($multipart) {
            $headers = $this->headerSelector->selectHeadersForMultipart(
                []
            );
        } else {
            $headers = $this->headerSelector->selectHeaders(
                [],
                []
            );
        }

        // for model (json/xml)
        if (isset($_tempBody)) {
            // $_tempBody is the method argument, if present
            $httpBody = $_tempBody;
            // \stdClass has no __toString(), so we should encode it manually
            if ($httpBody instanceof \stdClass && $headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode($httpBody);
            }
        } elseif (count($formParams) > 0) {
            if ($multipart) {
                $multipartContents = [];
                foreach ($formParams as $formParamName => $formParamValue) {
                    $multipartContents[] = [
                        'name' => $formParamName,
                        'contents' => $formParamValue
                    ];
                }
                // for HTTP post (form)
                $httpBody = new MultipartStream($multipartContents);

            } elseif ($headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode($formParams);

            } else {
                // for HTTP post (form)
                $httpBody = \GuzzleHttp\Psr7\build_query($formParams);
            }
        }


        $defaultHeaders = [];
        if ($this->config->getUserAgent()) {
            $defaultHeaders['User-Agent'] = $this->config->getUserAgent();
        }

        $headers = array_merge(
            $defaultHeaders,
            $headerParams,
            $headers
        );

        $query = \GuzzleHttp\Psr7\build_query($queryParams);
        return new Request(
            'GET',
            $this->config->getHost() . $resourcePath . ($query ? "?{$query}" : ''),
            $headers,
            $httpBody
        );
    }

    /**
     * Operation updateBusinessReply
     *
     * https://api.brownbook.net/businesses/reviews/{replyId}
     *
     * @param  \Swagger\Client\Model\ReplyReplyIdBody $body body (required)
     * @param  string $reply_id Id of reply (required)
     * @param  string $authorization authorization (optional, default to Bearer {token})
     *
     * @throws \Swagger\Client\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return \Swagger\Client\Model\ReplyEditedResponse[]
     */
    public function updateBusinessReply($body, $reply_id, $authorization = 'Bearer {token}')
    {
        list($response) = $this->updateBusinessReplyWithHttpInfo($body, $reply_id, $authorization);
        return $response;
    }

    /**
     * Operation updateBusinessReplyWithHttpInfo
     *
     * https://api.brownbook.net/businesses/reviews/{replyId}
     *
     * @param  \Swagger\Client\Model\ReplyReplyIdBody $body (required)
     * @param  string $reply_id Id of reply (required)
     * @param  string $authorization (optional, default to Bearer {token})
     *
     * @throws \Swagger\Client\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return array of \Swagger\Client\Model\ReplyEditedResponse[], HTTP status code, HTTP response headers (array of strings)
     */
    public function updateBusinessReplyWithHttpInfo($body, $reply_id, $authorization = 'Bearer {token}')
    {
        $returnType = '\Swagger\Client\Model\ReplyEditedResponse[]';
        $request = $this->updateBusinessReplyRequest($body, $reply_id, $authorization);

        try {
            $options = $this->createHttpClientOption();
            try {
                $response = $this->client->send($request, $options);
            } catch (RequestException $e) {
                throw new ApiException(
                    "[{$e->getCode()}] {$e->getMessage()}",
                    $e->getCode(),
                    $e->getResponse() ? $e->getResponse()->getHeaders() : null,
                    $e->getResponse() ? $e->getResponse()->getBody()->getContents() : null
                );
            }

            $statusCode = $response->getStatusCode();

            if ($statusCode < 200 || $statusCode > 299) {
                throw new ApiException(
                    sprintf(
                        '[%d] Error connecting to the API (%s)',
                        $statusCode,
                        $request->getUri()
                    ),
                    $statusCode,
                    $response->getHeaders(),
                    $response->getBody()
                );
            }

            $responseBody = $response->getBody();
            if ($returnType === '\SplFileObject') {
                $content = $responseBody; //stream goes to serializer
            } else {
                $content = $responseBody->getContents();
                if (!in_array($returnType, ['string','integer','bool'])) {
                    $content = json_decode($content);
                }
            }

            return [
                ObjectSerializer::deserialize($content, $returnType, []),
                $response->getStatusCode(),
                $response->getHeaders()
            ];

        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 200:
                    $data = ObjectSerializer::deserialize(
                        $e->getResponseBody(),
                        '\Swagger\Client\Model\ReplyEditedResponse[]',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
                case 400:
                    $data = ObjectSerializer::deserialize(
                        $e->getResponseBody(),
                        '\Swagger\Client\Model\ReplyEditedResponse400[]',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
                case 401:
                    $data = ObjectSerializer::deserialize(
                        $e->getResponseBody(),
                        '\Swagger\Client\Model\ReplyResponse401[]',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
                case 404:
                    $data = ObjectSerializer::deserialize(
                        $e->getResponseBody(),
                        '\Swagger\Client\Model\ReplyResponse404R[]',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
                case 405:
                    $data = ObjectSerializer::deserialize(
                        $e->getResponseBody(),
                        '\Swagger\Client\Model\ReplyEditedResponse400[]',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
            }
            throw $e;
        }
    }

    /**
     * Operation updateBusinessReplyAsync
     *
     * https://api.brownbook.net/businesses/reviews/{replyId}
     *
     * @param  \Swagger\Client\Model\ReplyReplyIdBody $body (required)
     * @param  string $reply_id Id of reply (required)
     * @param  string $authorization (optional, default to Bearer {token})
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function updateBusinessReplyAsync($body, $reply_id, $authorization = 'Bearer {token}')
    {
        return $this->updateBusinessReplyAsyncWithHttpInfo($body, $reply_id, $authorization)
            ->then(
                function ($response) {
                    return $response[0];
                }
            );
    }

    /**
     * Operation updateBusinessReplyAsyncWithHttpInfo
     *
     * https://api.brownbook.net/businesses/reviews/{replyId}
     *
     * @param  \Swagger\Client\Model\ReplyReplyIdBody $body (required)
     * @param  string $reply_id Id of reply (required)
     * @param  string $authorization (optional, default to Bearer {token})
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function updateBusinessReplyAsyncWithHttpInfo($body, $reply_id, $authorization = 'Bearer {token}')
    {
        $returnType = '\Swagger\Client\Model\ReplyEditedResponse[]';
        $request = $this->updateBusinessReplyRequest($body, $reply_id, $authorization);

        return $this->client
            ->sendAsync($request, $this->createHttpClientOption())
            ->then(
                function ($response) use ($returnType) {
                    $responseBody = $response->getBody();
                    if ($returnType === '\SplFileObject') {
                        $content = $responseBody; //stream goes to serializer
                    } else {
                        $content = $responseBody->getContents();
                        if ($returnType !== 'string') {
                            $content = json_decode($content);
                        }
                    }

                    return [
                        ObjectSerializer::deserialize($content, $returnType, []),
                        $response->getStatusCode(),
                        $response->getHeaders()
                    ];
                },
                function ($exception) {
                    $response = $exception->getResponse();
                    $statusCode = $response->getStatusCode();
                    throw new ApiException(
                        sprintf(
                            '[%d] Error connecting to the API (%s)',
                            $statusCode,
                            $exception->getRequest()->getUri()
                        ),
                        $statusCode,
                        $response->getHeaders(),
                        $response->getBody()
                    );
                }
            );
    }

    /**
     * Create request for operation 'updateBusinessReply'
     *
     * @param  \Swagger\Client\Model\ReplyReplyIdBody $body (required)
     * @param  string $reply_id Id of reply (required)
     * @param  string $authorization (optional, default to Bearer {token})
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Psr7\Request
     */
    protected function updateBusinessReplyRequest($body, $reply_id, $authorization = 'Bearer {token}')
    {
        // verify the required parameter 'body' is set
        if ($body === null || (is_array($body) && count($body) === 0)) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $body when calling updateBusinessReply'
            );
        }
        // verify the required parameter 'reply_id' is set
        if ($reply_id === null || (is_array($reply_id) && count($reply_id) === 0)) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $reply_id when calling updateBusinessReply'
            );
        }

        $resourcePath = '/businesses/reviews/reply/{replyId}';
        $formParams = [];
        $queryParams = [];
        $headerParams = [];
        $httpBody = '';
        $multipart = false;

        // header params
        if ($authorization !== null) {
            $headerParams['Authorization'] = ObjectSerializer::toHeaderValue($authorization);
        }

        // path params
        if ($reply_id !== null) {
            $resourcePath = str_replace(
                '{' . 'replyId' . '}',
                ObjectSerializer::toPathValue($reply_id),
                $resourcePath
            );
        }

        // body params
        $_tempBody = null;
        if (isset($body)) {
            $_tempBody = $body;
        }

        if ($multipart) {
            $headers = $this->headerSelector->selectHeadersForMultipart(
                ['application/json']
            );
        } else {
            $headers = $this->headerSelector->selectHeaders(
                ['application/json'],
                ['application/json']
            );
        }

        // for model (json/xml)
        if (isset($_tempBody)) {
            // $_tempBody is the method argument, if present
            $httpBody = $_tempBody;
            // \stdClass has no __toString(), so we should encode it manually
            if ($httpBody instanceof \stdClass && $headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode($httpBody);
            }
        } elseif (count($formParams) > 0) {
            if ($multipart) {
                $multipartContents = [];
                foreach ($formParams as $formParamName => $formParamValue) {
                    $multipartContents[] = [
                        'name' => $formParamName,
                        'contents' => $formParamValue
                    ];
                }
                // for HTTP post (form)
                $httpBody = new MultipartStream($multipartContents);

            } elseif ($headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode($formParams);

            } else {
                // for HTTP post (form)
                $httpBody = \GuzzleHttp\Psr7\build_query($formParams);
            }
        }


        $defaultHeaders = [];
        if ($this->config->getUserAgent()) {
            $defaultHeaders['User-Agent'] = $this->config->getUserAgent();
        }

        $headers = array_merge(
            $defaultHeaders,
            $headerParams,
            $headers
        );

        $query = \GuzzleHttp\Psr7\build_query($queryParams);
        return new Request(
            'POST',
            $this->config->getHost() . $resourcePath . ($query ? "?{$query}" : ''),
            $headers,
            $httpBody
        );
    }

    /**
     * Operation updatedBusiness
     *
     * https://api.brownbook.net/businesses/{businessId}
     *
     * @param  \Swagger\Client\Model\BusinessDetailsWhenUpdate $body Business details object (required)
     * @param  string $business_id business_id (required)
     * @param  string $authorization authorization (optional, default to Bearer {token})
     *
     * @throws \Swagger\Client\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return \Swagger\Client\Model\Business
     */
    public function updatedBusiness($body, $business_id, $authorization = 'Bearer {token}')
    {
        list($response) = $this->updatedBusinessWithHttpInfo($body, $business_id, $authorization);
        return $response;
    }

    /**
     * Operation updatedBusinessWithHttpInfo
     *
     * https://api.brownbook.net/businesses/{businessId}
     *
     * @param  \Swagger\Client\Model\BusinessDetailsWhenUpdate $body Business details object (required)
     * @param  string $business_id (required)
     * @param  string $authorization (optional, default to Bearer {token})
     *
     * @throws \Swagger\Client\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return array of \Swagger\Client\Model\Business, HTTP status code, HTTP response headers (array of strings)
     */
    public function updatedBusinessWithHttpInfo($body, $business_id, $authorization = 'Bearer {token}')
    {
        $returnType = '\Swagger\Client\Model\Business';
        $request = $this->updatedBusinessRequest($body, $business_id, $authorization);

        try {
            $options = $this->createHttpClientOption();
            try {
                $response = $this->client->send($request, $options);
            } catch (RequestException $e) {
                throw new ApiException(
                    "[{$e->getCode()}] {$e->getMessage()}",
                    $e->getCode(),
                    $e->getResponse() ? $e->getResponse()->getHeaders() : null,
                    $e->getResponse() ? $e->getResponse()->getBody()->getContents() : null
                );
            }

            $statusCode = $response->getStatusCode();

            if ($statusCode < 200 || $statusCode > 299) {
                throw new ApiException(
                    sprintf(
                        '[%d] Error connecting to the API (%s)',
                        $statusCode,
                        $request->getUri()
                    ),
                    $statusCode,
                    $response->getHeaders(),
                    $response->getBody()
                );
            }

            $responseBody = $response->getBody();
            if ($returnType === '\SplFileObject') {
                $content = $responseBody; //stream goes to serializer
            } else {
                $content = $responseBody->getContents();
                if (!in_array($returnType, ['string','integer','bool'])) {
                    $content = json_decode($content);
                }
            }

            return [
                ObjectSerializer::deserialize($content, $returnType, []),
                $response->getStatusCode(),
                $response->getHeaders()
            ];

        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 200:
                    $data = ObjectSerializer::deserialize(
                        $e->getResponseBody(),
                        '\Swagger\Client\Model\Business',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
                case 400:
                    $data = ObjectSerializer::deserialize(
                        $e->getResponseBody(),
                        '\Swagger\Client\Model\BusinessSchemaError',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
                case 402:
                    $data = ObjectSerializer::deserialize(
                        $e->getResponseBody(),
                        '\Swagger\Client\Model\TokenExpired',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
                case 405:
                    $data = ObjectSerializer::deserialize(
                        $e->getResponseBody(),
                        '\Swagger\Client\Model\BusinessCreatingError',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
                case 500:
                    $data = ObjectSerializer::deserialize(
                        $e->getResponseBody(),
                        '\Swagger\Client\Model\Business500Error',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
            }
            throw $e;
        }
    }

    /**
     * Operation updatedBusinessAsync
     *
     * https://api.brownbook.net/businesses/{businessId}
     *
     * @param  \Swagger\Client\Model\BusinessDetailsWhenUpdate $body Business details object (required)
     * @param  string $business_id (required)
     * @param  string $authorization (optional, default to Bearer {token})
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function updatedBusinessAsync($body, $business_id, $authorization = 'Bearer {token}')
    {
        return $this->updatedBusinessAsyncWithHttpInfo($body, $business_id, $authorization)
            ->then(
                function ($response) {
                    return $response[0];
                }
            );
    }

    /**
     * Operation updatedBusinessAsyncWithHttpInfo
     *
     * https://api.brownbook.net/businesses/{businessId}
     *
     * @param  \Swagger\Client\Model\BusinessDetailsWhenUpdate $body Business details object (required)
     * @param  string $business_id (required)
     * @param  string $authorization (optional, default to Bearer {token})
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function updatedBusinessAsyncWithHttpInfo($body, $business_id, $authorization = 'Bearer {token}')
    {
        $returnType = '\Swagger\Client\Model\Business';
        $request = $this->updatedBusinessRequest($body, $business_id, $authorization);

        return $this->client
            ->sendAsync($request, $this->createHttpClientOption())
            ->then(
                function ($response) use ($returnType) {
                    $responseBody = $response->getBody();
                    if ($returnType === '\SplFileObject') {
                        $content = $responseBody; //stream goes to serializer
                    } else {
                        $content = $responseBody->getContents();
                        if ($returnType !== 'string') {
                            $content = json_decode($content);
                        }
                    }

                    return [
                        ObjectSerializer::deserialize($content, $returnType, []),
                        $response->getStatusCode(),
                        $response->getHeaders()
                    ];
                },
                function ($exception) {
                    $response = $exception->getResponse();
                    $statusCode = $response->getStatusCode();
                    throw new ApiException(
                        sprintf(
                            '[%d] Error connecting to the API (%s)',
                            $statusCode,
                            $exception->getRequest()->getUri()
                        ),
                        $statusCode,
                        $response->getHeaders(),
                        $response->getBody()
                    );
                }
            );
    }

    /**
     * Create request for operation 'updatedBusiness'
     *
     * @param  \Swagger\Client\Model\BusinessDetailsWhenUpdate $body Business details object (required)
     * @param  string $business_id (required)
     * @param  string $authorization (optional, default to Bearer {token})
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Psr7\Request
     */
    protected function updatedBusinessRequest($body, $business_id, $authorization = 'Bearer {token}')
    {
        // verify the required parameter 'body' is set
        if ($body === null || (is_array($body) && count($body) === 0)) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $body when calling updatedBusiness'
            );
        }
        // verify the required parameter 'business_id' is set
        if ($business_id === null || (is_array($business_id) && count($business_id) === 0)) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $business_id when calling updatedBusiness'
            );
        }

        $resourcePath = '/businesses/{businessId}';
        $formParams = [];
        $queryParams = [];
        $headerParams = [];
        $httpBody = '';
        $multipart = false;

        // header params
        if ($authorization !== null) {
            $headerParams['Authorization'] = ObjectSerializer::toHeaderValue($authorization);
        }

        // path params
        if ($business_id !== null) {
            $resourcePath = str_replace(
                '{' . 'businessId' . '}',
                ObjectSerializer::toPathValue($business_id),
                $resourcePath
            );
        }

        // body params
        $_tempBody = null;
        if (isset($body)) {
            $_tempBody = $body;
        }

        if ($multipart) {
            $headers = $this->headerSelector->selectHeadersForMultipart(
                ['application/json']
            );
        } else {
            $headers = $this->headerSelector->selectHeaders(
                ['application/json'],
                ['application/json']
            );
        }

        // for model (json/xml)
        if (isset($_tempBody)) {
            // $_tempBody is the method argument, if present
            $httpBody = $_tempBody;
            // \stdClass has no __toString(), so we should encode it manually
            if ($httpBody instanceof \stdClass && $headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode($httpBody);
            }
        } elseif (count($formParams) > 0) {
            if ($multipart) {
                $multipartContents = [];
                foreach ($formParams as $formParamName => $formParamValue) {
                    $multipartContents[] = [
                        'name' => $formParamName,
                        'contents' => $formParamValue
                    ];
                }
                // for HTTP post (form)
                $httpBody = new MultipartStream($multipartContents);

            } elseif ($headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode($formParams);

            } else {
                // for HTTP post (form)
                $httpBody = \GuzzleHttp\Psr7\build_query($formParams);
            }
        }


        $defaultHeaders = [];
        if ($this->config->getUserAgent()) {
            $defaultHeaders['User-Agent'] = $this->config->getUserAgent();
        }

        $headers = array_merge(
            $defaultHeaders,
            $headerParams,
            $headers
        );

        $query = \GuzzleHttp\Psr7\build_query($queryParams);
        return new Request(
            'POST',
            $this->config->getHost() . $resourcePath . ($query ? "?{$query}" : ''),
            $headers,
            $httpBody
        );
    }

    /**
     * Create http client option
     *
     * @throws \RuntimeException on file opening failure
     * @return array of http client options
     */
    protected function createHttpClientOption()
    {
        $options = [];
        if ($this->config->getDebug()) {
            $options[RequestOptions::DEBUG] = fopen($this->config->getDebugFile(), 'a');
            if (!$options[RequestOptions::DEBUG]) {
                throw new \RuntimeException('Failed to open the debug file: ' . $this->config->getDebugFile());
            }
        }

        return $options;
    }
}
